// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.


// Take the name prefix into account.
#define yylex   ecnflex



#include "ecnfparser.hh"


// Unqualified %code blocks.
#line 57 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"

	// Prototype for the yylex function
	static int ecnflex(MinisatID::ECNFParser::semantic_type * yylval, MinisatID::ECNFParser::location_type * yyloc, MinisatID::ECNFScanner &scanner);
		
	// TODO External state (to be removed in future)
	FODOTTranslator*	fodottrans = NULL;
	LParseTranslator*	simpletrans = NULL;
	
	template<class Wrapper>
	void readCNFModalHierLevel(Wrapper* wrapper, bool existential, const vector<Lit>& rigidlits, TheoryID& level, bool& negatemod, int& maxatom);
	
	/**
	 * CR-CheckResult: checks the result of passing some data to the solvers.
	 * The result is false if unsat was already detected.
	 */
	template<class Wrapper, class T>
	void CR(Wrapper* wrapper, T& formula, TheoryID level);
	
	MinisatID::Atom cAtom(string* c);
	MinisatID::Lit cLiteral(string* c);
	MinisatID::Weight cWeight(string* s);
	uint cID(string* c);
	VarID cVarID(string* c);
	
	// Convert integer to string
	std::string itos(int n) {
	   if(n == 0) return "0";
	   std::string s;
		int a = abs(n);
	   while(a > 0) {
	      int temp = a % 10;
	      char c = '0' + temp;
	      s = c + s;
	      a = (a - temp) / 10;
	   }
		if(n < 0) return ('-' + s);
	   else return s;
	}
	
	// Parsing
	
	void addTuple(int literalnumber, const string& atom);
	void parsetruelist(std::vector<int>* vi);
	void parsearbitlist(std::vector<int>* vi);
	void parsetype(std::string* name, std::vector<std::string>* inter);
	void parsepred(std::string* name, int num, std::vector<std::string>* ptypes, bool f);
	
	int defaultdefID = 1;
	enum ECNF_VERSION {VERSION_NONE, VERSION_OLD, VERSION_NEW}; 
	ECNF_VERSION currentreadversion = VERSION_NONE;
	
	void checkVersion(ECNF_VERSION version);

#line 102 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 16 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
namespace MinisatID {
#line 195 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"

  /// Build a parser object.
  ECNFParser::ECNFParser (MinisatID::ECNFScanner &scanner_yyarg, MinisatID::ExternalConstraintVisitor* wrapper_yyarg, TheoryID theoryid_yyarg, bool negatemod_yyarg, int maxatom_yyarg, std::vector<Lit> rigidlits_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      scanner (scanner_yyarg),
      wrapper (wrapper_yyarg),
      theoryid (theoryid_yyarg),
      negatemod (negatemod_yyarg),
      maxatom (maxatom_yyarg),
      rigidlits (rigidlits_yyarg)
  {}

  ECNFParser::~ECNFParser ()
  {}

  ECNFParser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/

  // basic_symbol.
  template <typename Base>
  ECNFParser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value (that.value)
    , location (that.location)
  {}


  /// Constructor for valueless symbols.
  template <typename Base>
  ECNFParser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_MOVE_REF (location_type) l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  ECNFParser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_RVREF (value_type) v, YY_RVREF (location_type) l)
    : Base (t)
    , value (YY_MOVE (v))
    , location (YY_MOVE (l))
  {}


  template <typename Base>
  ECNFParser::symbol_kind_type
  ECNFParser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  template <typename Base>
  bool
  ECNFParser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  ECNFParser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    value = YY_MOVE (s.value);
    location = YY_MOVE (s.location);
  }

  // by_kind.
  ECNFParser::by_kind::by_kind () YY_NOEXCEPT
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  ECNFParser::by_kind::by_kind (by_kind&& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  ECNFParser::by_kind::by_kind (const by_kind& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {}

  ECNFParser::by_kind::by_kind (token_kind_type t) YY_NOEXCEPT
    : kind_ (yytranslate_ (t))
  {}



  void
  ECNFParser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  ECNFParser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  ECNFParser::symbol_kind_type
  ECNFParser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }


  ECNFParser::symbol_kind_type
  ECNFParser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }



  // by_state.
  ECNFParser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  ECNFParser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  ECNFParser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  ECNFParser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  ECNFParser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  ECNFParser::symbol_kind_type
  ECNFParser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  ECNFParser::stack_symbol_type::stack_symbol_type ()
  {}

  ECNFParser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.value), YY_MOVE (that.location))
  {
#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  ECNFParser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.value), YY_MOVE (that.location))
  {
    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  ECNFParser::stack_symbol_type&
  ECNFParser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    return *this;
  }

  ECNFParser::stack_symbol_type&
  ECNFParser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  ECNFParser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);

    // User destructor.
    YY_USE (yysym.kind ());
  }

#if YYDEBUG
  template <typename Base>
  void
  ECNFParser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  ECNFParser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  ECNFParser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  ECNFParser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  ECNFParser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  ECNFParser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  ECNFParser::debug_level_type
  ECNFParser::debug_level () const
  {
    return yydebug_;
  }

  void
  ECNFParser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  ECNFParser::state_type
  ECNFParser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  ECNFParser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  ECNFParser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  ECNFParser::operator() ()
  {
    return parse ();
  }

  int
  ECNFParser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, scanner));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* If YYLEN is nonzero, implement the default value of the
         action: '$$ = $1'.  Otherwise, use the top of the stack.

         Otherwise, the following line sets YYLHS.VALUE to garbage.
         This behavior is undocumented and Bison users should not rely
         upon it.  */
      if (yylen)
        yylhs.value = yystack_[yylen - 1].value;
      else
        yylhs.value = yystack_[0].value;

      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 3: // $@1: %empty
#line 188 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                      { maxatom = (yystack_[1].value.integer); }
#line 673 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 4: // $@2: %empty
#line 188 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                                 {
				if(negatemod){
					readCNFModalHierLevel(wrapper, true, rigidlits, theoryid, negatemod, maxatom);
				}
				theoryid = TheoryID(theoryid.id-1);
			}
#line 684 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 13: // cnfclause: body ZERO
#line 210 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                {	
					Disjunction clause(*(yystack_[1].value.vlits));
					CR(wrapper, clause, theoryid);
					delete (yystack_[1].value.vlits);
				}
#line 694 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 14: // $@3: %empty
#line 221 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                { 	readCNFModalHierLevel(wrapper, (yystack_[0].value.boolean), rigidlits, theoryid, negatemod, maxatom); }
#line 700 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 15: // $@4: %empty
#line 222 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                             { rigidlits.insert(rigidlits.end(), (*(yystack_[0].value.vlits)).cbegin(), (*(yystack_[0].value.vlits)).cend()); delete((yystack_[0].value.vlits)); }
#line 706 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 17: // $@5: %empty
#line 224 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                { 	readCNFModalHierLevel(wrapper, (yystack_[0].value.boolean), rigidlits, theoryid, negatemod, maxatom); }
#line 712 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 18: // $@6: %empty
#line 225 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                             { rigidlits.insert(rigidlits.end(), (*(yystack_[0].value.vlits)).cbegin(), (*(yystack_[0].value.vlits)).cend()); delete((yystack_[0].value.vlits)); }
#line 718 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 36: // level: LEVEL number ZERO
#line 250 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                    {
					MAssert((yystack_[1].value.integer)>0); 
					theoryid = TheoryID((uint)(yystack_[1].value.integer)); 
				}
#line 727 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 37: // subtheory: SUBTHEORY number NUMBER body ZERO
#line 257 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        {	
				std::vector<Atom> atoms;
				for(auto lit:*(yystack_[1].value.vlits)){
					atoms.push_back(lit.getAtom());
				}
				SubTheory sub(cAtom((yystack_[2].value.str)), TheoryID((uint)(yystack_[3].value.integer)), atoms);
				CR(wrapper, sub, theoryid);
				delete (yystack_[1].value.vlits);
			}
#line 741 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 38: // subsetmnmz: SUBSETMINDEFN body ZERO
#line 269 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        {
				MinimizeSubset mnm(1, *(yystack_[1].value.vlits));
				CR(wrapper, mnm, theoryid);
				delete (yystack_[1].value.vlits); 
			}
#line 751 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 39: // varmnmz: VARMINDEFN NUMBER ZERO
#line 275 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { 
				OptimizeVar mnm(1, cVarID((yystack_[1].value.str)), true);
				CR(wrapper, mnm, theoryid);
			}
#line 760 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 40: // varmxmz: VARMAXDEFN NUMBER ZERO
#line 281 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { 
				OptimizeVar mnm(1, cVarID((yystack_[1].value.str)), false);
				CR(wrapper, mnm, theoryid);
			}
#line 769 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 41: // aggmnmz: AGGMINDEFN AGGDEFN NUMBER ZERO
#line 287 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        {
				MinimizeAgg mnm(1, cID((yystack_[1].value.str)), (yystack_[2].value.aggr));
				CR(wrapper, mnm, theoryid);
				delete (yystack_[1].value.str);
			}
#line 779 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 42: // summnmz: AGGMINDEFN AGGDEFN NUMBER NUMBER ZERO
#line 295 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        {
				MinimizeAgg mnm(1, cID((yystack_[1].value.str)), (yystack_[3].value.aggr));
				CR(wrapper, mnm, theoryid);
				delete (yystack_[2].value.str); delete (yystack_[1].value.str);
			}
#line 789 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 43: // clause: body ZERO
#line 302 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        {
				Disjunction clause(*(yystack_[1].value.vlits));
				CR(wrapper, clause, theoryid);
				delete (yystack_[1].value.vlits);
			}
#line 799 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 44: // rule: SEMDEFN NUMBER body ZERO
#line 310 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { 	
				checkVersion(VERSION_OLD);
				if((yystack_[3].value.sem)==AggSem::OR){
					error(yystack_[3].location, "Incorrect rule type specification \"O\", should be either \"D\" or \"C\".");
				}
				Rule rule(cAtom((yystack_[2].value.str)), *(yystack_[1].value.vlits), (yystack_[3].value.sem)==AggSem::COMP, defaultdefID, false); //AggSem is bit of a hack, to be fixed
				delete (yystack_[2].value.str); delete (yystack_[1].value.vlits);
				CR(wrapper, rule, theoryid);
			}
#line 813 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 45: // rule: SEMDEFN NUMBER DELIM NUMBER DEFOP body ZERO
#line 322 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { 	
				checkVersion(VERSION_NEW);
				if((yystack_[6].value.sem)==AggSem::OR){
					error(yystack_[6].location, "Incorrect rule type specification \"O\", should be either \"D\" or \"C\".");
				}
				Rule rule(cAtom((yystack_[3].value.str)), *(yystack_[1].value.vlits), (yystack_[6].value.sem)==AggSem::COMP, cID((yystack_[5].value.str)), false);//AggSem is bit of a hack, to be fixed
				delete (yystack_[5].value.str); delete (yystack_[3].value.str); delete (yystack_[1].value.vlits);
				CR(wrapper, rule, theoryid);
			}
#line 827 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 46: // implication: IMPLICATION SEMDEFN NUMBER IMPL body ZERO
#line 334 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { 	
				Implication implic(cLiteral((yystack_[3].value.str)), (yystack_[2].value.impl), *(yystack_[1].value.vlits), (yystack_[4].value.sem)==AggSem::COMP);
				delete (yystack_[3].value.str); delete (yystack_[1].value.vlits);
				CR(wrapper, implic, theoryid);
			}
#line 837 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 47: // agg: AGGDEFN SEMDEFN SIGNDEFN NUMBER NUMBER weight ZERO
#line 342 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        {	
				if((yystack_[5].value.sem) == AggSem::DEF){
					checkVersion(VERSION_OLD);
				}
	
				Aggregate agg(cLiteral((yystack_[3].value.str)), cID((yystack_[2].value.str)), cWeight((yystack_[1].value.str)), (yystack_[6].value.aggr), (yystack_[4].value.sign), (yystack_[5].value.sem), defaultdefID, false);
				CR(wrapper, agg, theoryid);
				delete (yystack_[3].value.str); delete (yystack_[2].value.str); delete (yystack_[1].value.str);
			}
#line 851 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 48: // agg: AGGDEFN ORSEM SIGNDEFN NUMBER NUMBER weight ZERO
#line 352 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        {	
				Aggregate agg(cLiteral((yystack_[3].value.str)), cID((yystack_[2].value.str)), cWeight((yystack_[1].value.str)), (yystack_[6].value.aggr), (yystack_[4].value.sign), AggSem::OR, defaultdefID, false);
				CR(wrapper, agg, theoryid);
				delete (yystack_[3].value.str); delete (yystack_[2].value.str); delete (yystack_[1].value.str);
			}
#line 861 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 49: // agg: AGGDEFN DEFOP NUMBER SIGNDEFN NUMBER NUMBER weight ZERO
#line 358 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        {	
				checkVersion(VERSION_NEW);

				Aggregate agg(mkPosLit(cAtom((yystack_[3].value.str))), cID((yystack_[2].value.str)), cWeight((yystack_[1].value.str)), (yystack_[7].value.aggr), (yystack_[4].value.sign), AggSem::DEF, cID((yystack_[5].value.str)), false);
				CR(wrapper, agg, theoryid);
				delete (yystack_[3].value.str); delete (yystack_[2].value.str); delete (yystack_[1].value.str);
			}
#line 873 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 50: // set: SETDEFN NUMBER body ZERO
#line 368 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { 	
				auto set = createSet(cID((yystack_[2].value.str)), *(yystack_[1].value.vlits), 1);
				CR(wrapper, set, theoryid);
				delete (yystack_[2].value.str); delete (yystack_[1].value.vlits);
			}
#line 883 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 51: // wset: WSETDEFN NUMBER wbody ZERO
#line 376 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        {	
				WLSet set(cID((yystack_[2].value.str)), *(yystack_[1].value.vlws));
				delete (yystack_[2].value.str); delete (yystack_[1].value.vlws);
				CR(wrapper, set, theoryid);
			}
#line 893 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 52: // intvar: INTVAR varid weight weight ZERO
#line 386 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        {
				IntVarRange var((yystack_[3].value.varid), cWeight((yystack_[2].value.str)), cWeight((yystack_[1].value.str)));
				CR(wrapper, var, theoryid);
				delete (yystack_[2].value.str); delete (yystack_[1].value.str);
			}
#line 903 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 53: // intvar: INTVARDOM varid weightbody DELIM ZERO
#line 392 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        {
				IntVarEnum var((yystack_[3].value.varid), *(yystack_[2].value.vweights));
				CR(wrapper, var, theoryid);
				delete (yystack_[2].value.vweights);
			}
#line 913 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 54: // intvar: PARTIAL INTVAR varid NUMBER weight weight ZERO
#line 398 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        {
				IntVarRange var((yystack_[4].value.varid), cWeight((yystack_[2].value.str)), cWeight((yystack_[1].value.str)), cLiteral((yystack_[3].value.str)));
				CR(wrapper, var, theoryid);
				delete (yystack_[3].value.str); delete (yystack_[2].value.str);
			}
#line 923 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 55: // intvar: PARTIAL INTVARDOM varid NUMBER weightbody DELIM ZERO
#line 404 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        {
				IntVarEnum var((yystack_[4].value.varid), *(yystack_[2].value.vweights), cLiteral((yystack_[3].value.str)));
				CR(wrapper, var, theoryid);
				delete (yystack_[3].value.str);
			}
#line 933 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 56: // cpconstraint: BINTRI NUMBER varid REL weight ZERO
#line 420 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { 	
				CPBinaryRel binrel(mkPosLit(cAtom((yystack_[4].value.str))), (yystack_[3].value.varid), (yystack_[2].value.rel), cWeight((yystack_[1].value.str)));
				CR(wrapper, binrel, theoryid);
				delete (yystack_[4].value.str); delete (yystack_[1].value.str);
			}
#line 943 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 57: // cpconstraint: BINTRT NUMBER varid REL varid ZERO
#line 426 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { 	
				CPBinaryRelVar binrel(mkPosLit(cAtom((yystack_[4].value.str))), (yystack_[3].value.varid), (yystack_[2].value.rel), (yystack_[1].value.varid));
				CR(wrapper, binrel, theoryid);
				delete (yystack_[4].value.str);
			}
#line 953 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 58: // cpconstraint: CPSUM NUMBER body DELIM possiblyemptyvaridbody DELIM weightbody REL weight ZERO
#line 432 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { 	
				CPSumWeighted sum(mkPosLit(cAtom((yystack_[8].value.str))), *(yystack_[7].value.vlits), *(yystack_[5].value.varids), *(yystack_[3].value.vweights), (yystack_[2].value.rel), cWeight((yystack_[1].value.str)));
				CR(wrapper, sum, theoryid);
				delete (yystack_[8].value.str); delete (yystack_[7].value.vlits); delete (yystack_[5].value.varids); delete (yystack_[3].value.vweights); delete (yystack_[1].value.str);
			}
#line 963 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 59: // cpconstraint: CPPROD NUMBER body DELIM possiblyemptyvaridbody DELIM weight REL varid ZERO
#line 438 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { 	
				CPProdWeighted prod(mkPosLit(cAtom((yystack_[8].value.str))), *(yystack_[7].value.vlits), *(yystack_[5].value.varids), cWeight((yystack_[3].value.str)), (yystack_[2].value.rel), (yystack_[1].value.varid));
				CR(wrapper, prod, theoryid);
				delete (yystack_[8].value.str); delete (yystack_[7].value.vlits); delete (yystack_[5].value.varids); delete (yystack_[3].value.str);
			}
#line 973 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 60: // cpconstraint: DISTINCT varidbody DELIM ZERO
#line 445 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { 	
				CPAllDiff alldiff(*(yystack_[2].value.varids));
				CR(wrapper, alldiff, theoryid);
				delete (yystack_[2].value.varids);
			}
#line 983 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 62: // $@7: %empty
#line 456 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                {
					fodottrans = new FODOTTranslator(wrapper->getOptions().transformat==OutputFormat::ASP);	
					wrapper->setTranslator(fodottrans);
				}
#line 992 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 64: // $@8: %empty
#line 463 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                {	
					simpletrans = new LParseTranslator();
					wrapper->setTranslator(simpletrans);
				}
#line 1001 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 68: // type: TYPE identifier ':' idnlist
#line 474 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                { parsetype((yystack_[2].value.str),(yystack_[0].value.vstr)); delete((yystack_[2].value.str)); delete((yystack_[0].value.vstr));	}
#line 1007 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 71: // pred: SHOWPRED T_NUM identifier ':' uint
#line 481 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                        { parsepred((yystack_[2].value.str),(yystack_[3].value.integer),(yystack_[0].value.vstr),false); delete((yystack_[2].value.str)); delete((yystack_[0].value.vstr));	}
#line 1013 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 72: // pred: PRED T_NUM identifier ':' uint
#line 482 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                                        { delete((yystack_[2].value.str)); delete((yystack_[0].value.vstr));								}
#line 1019 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 75: // func: SHOWFUNC T_NUM identifier ':' uint
#line 489 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                        { parsepred((yystack_[2].value.str),(yystack_[3].value.integer),(yystack_[0].value.vstr),true); delete((yystack_[2].value.str)); delete((yystack_[0].value.vstr)); 	}
#line 1025 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 76: // func: FUNC T_NUM identifier ':' uint
#line 490 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                         { delete((yystack_[2].value.str)); delete((yystack_[0].value.vstr)); }
#line 1031 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 77: // truelist: TRUE ':' numlist
#line 493 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                        { parsetruelist((yystack_[0].value.vints)); delete((yystack_[0].value.vints)); }
#line 1037 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 78: // arbitlist: ARBIT ':' numlist
#line 496 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                        { parsearbitlist((yystack_[0].value.vints)); delete((yystack_[0].value.vints)); }
#line 1043 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 79: // idnlist: idnlist identifier
#line 499 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                        { (yystack_[1].value.vstr)->push_back(*(yystack_[0].value.str)); (yylhs.value.vstr) = (yystack_[1].value.vstr); delete((yystack_[0].value.str)); }
#line 1049 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 80: // idnlist: idnlist T_NUM
#line 500 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                        { (yystack_[1].value.vstr)->push_back(itos((yystack_[0].value.integer))); (yylhs.value.vstr) = (yystack_[1].value.vstr); }
#line 1055 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 81: // idnlist: identifier
#line 501 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                        { (yylhs.value.vstr) = new vector<string>(1,(*(yystack_[0].value.str))); delete((yystack_[0].value.str));	}
#line 1061 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 82: // idnlist: T_NUM
#line 502 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                                { (yylhs.value.vstr) = new vector<string>(1,itos((yystack_[0].value.integer))); }
#line 1067 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 83: // uint: %empty
#line 505 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                        { (yylhs.value.vstr) = new vector<string>(0); }
#line 1073 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 84: // uint: uint identifier
#line 506 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                { (yystack_[1].value.vstr)->push_back(*(yystack_[0].value.str)); (yylhs.value.vstr) = (yystack_[1].value.vstr); delete((yystack_[0].value.str)); }
#line 1079 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 85: // numlist: %empty
#line 509 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                        { (yylhs.value.vints) = new vector<int>(0); }
#line 1085 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 86: // numlist: numlist T_NUM
#line 510 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                { (yystack_[1].value.vints)->push_back((yystack_[0].value.integer)); (yylhs.value.vints) = (yystack_[1].value.vints); }
#line 1091 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 87: // numlist: numlist identifier '/' T_NUM
#line 511 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                                { (yylhs.value.vints) = (yystack_[3].value.vints); }
#line 1097 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 88: // numlist: numlist identifier '/' T_NUM ':'
#line 512 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                           { (yylhs.value.vints) = (yystack_[4].value.vints); }
#line 1103 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 90: // tuplelist: tuplelist T_NUM DELIM identifier2
#line 516 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                            { addTuple((yystack_[2].value.integer), *(yystack_[0].value.str)); delete((yystack_[0].value.str)); }
#line 1109 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 91: // identifier: T_ID
#line 519 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { (yylhs.value.str) = (yystack_[0].value.str);	}
#line 1115 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 92: // identifier2: T_ID2
#line 522 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { (yylhs.value.str) = (yystack_[0].value.str);	}
#line 1121 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 93: // body: body NUMBER
#line 530 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                            { (yylhs.value.vlits) = (yystack_[1].value.vlits); (yylhs.value.vlits)->push_back(cLiteral((yystack_[0].value.str)));	delete((yystack_[0].value.str)); }
#line 1127 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 94: // body: %empty
#line 531 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                { (yylhs.value.vlits) = new std::vector<MinisatID::Lit>();	}
#line 1133 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 95: // $@9: %empty
#line 535 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { 
				if((yystack_[0].value.rel)!=MinisatID::EqType::EQ) { 
					throw MinisatID::idpexception("Weighted sets can only contain tuples with equality.\n");
				} 
			}
#line 1143 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 96: // wbody: wbody NUMBER REL $@9 weight
#line 541 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { (yylhs.value.vlws) = (yystack_[4].value.vlws); (yylhs.value.vlws)->push_back(MinisatID::WLtuple(cLiteral((yystack_[3].value.str)), cWeight((yystack_[0].value.str)))); delete((yystack_[3].value.str));  delete (yystack_[0].value.str);}
#line 1149 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 97: // $@10: %empty
#line 544 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { 
				if((yystack_[0].value.rel)!=MinisatID::EqType::EQ) { 
					throw MinisatID::idpexception("Weighted sets can only contain tuples with equality.\n");
				}
			}
#line 1159 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 98: // wbody: NUMBER REL $@10 weight
#line 550 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { (yylhs.value.vlws) = new std::vector<WLtuple>(1,MinisatID::WLtuple(cLiteral((yystack_[3].value.str)), cWeight((yystack_[0].value.str)))); delete((yystack_[3].value.str)); delete (yystack_[0].value.str);}
#line 1165 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 99: // weightbody: weightbody weight
#line 554 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                { (yylhs.value.vweights) = (yystack_[1].value.vweights); (yylhs.value.vweights)->push_back(cWeight((yystack_[0].value.str))); delete (yystack_[0].value.str); }
#line 1171 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 100: // weightbody: weight
#line 555 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                { (yylhs.value.vweights) = new vector<Weight>(1, cWeight((yystack_[0].value.str))); delete (yystack_[0].value.str);	}
#line 1177 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 101: // possiblyemptyvaridbody: varidbody
#line 558 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                     { (yylhs.value.varids)=(yystack_[0].value.varids);}
#line 1183 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 102: // possiblyemptyvaridbody: emptyvaridbody
#line 559 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                                                 { (yylhs.value.varids) = (yystack_[0].value.varids);}
#line 1189 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 103: // varidbody: varidbody varid
#line 562 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                        { (yylhs.value.varids) = (yystack_[1].value.varids); (yylhs.value.varids)->push_back((yystack_[0].value.varid));	}
#line 1195 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 104: // varidbody: varid
#line 563 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                        { (yylhs.value.varids) = new vector<VarID>(1, (yystack_[0].value.varid));	}
#line 1201 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 105: // emptyvaridbody: %empty
#line 566 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { (yylhs.value.varids) = new vector<VarID>(0);}
#line 1207 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 106: // varid: number
#line 568 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { 
				if((yystack_[0].value.integer)<0){
					throw MinisatID::idpexception("Variable IDs cannot be negative.\n");
				}
				(yylhs.value.varid) = {(uint)(yystack_[0].value.integer)};
			}
#line 1218 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 107: // number: NUMBER
#line 575 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { (yylhs.value.integer) = atoi((*(yystack_[0].value.str)).c_str()); delete((yystack_[0].value.str)); }
#line 1224 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 108: // number: ZERO
#line 576 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                { (yylhs.value.integer) = 0; }
#line 1230 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 109: // weight: NUMBER
#line 578 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                        { (yylhs.value.str) = (yystack_[0].value.str); }
#line 1236 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;

  case 110: // weight: ZERO
#line 579 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
                                { (yylhs.value.str) = new string("0"); }
#line 1242 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"
    break;


#line 1246 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  ECNFParser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  ECNFParser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  ECNFParser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // ECNFParser::context.
  ECNFParser::context::context (const ECNFParser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  ECNFParser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
  ECNFParser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  ECNFParser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short ECNFParser::yypact_ninf_ = -211;

  const signed char ECNFParser::yytable_ninf_ = -62;

  const short
  ECNFParser::yypact_[] =
  {
      32,    30,  -211,    18,  -211,  -211,    30,    25,  -211,   -16,
    -211,  -211,  -211,   127,   -11,    33,  -211,    41,    52,    40,
      63,    71,    75,     8,    30,    30,    45,    79,    86,    30,
      96,    98,    24,    30,    30,  -211,  -211,  -211,  -211,  -211,
    -211,  -211,  -211,  -211,  -211,  -211,  -211,  -211,  -211,  -211,
    -211,  -211,  -211,    67,  -211,    76,  -211,    78,    83,   106,
     108,   111,  -211,   115,    99,   130,   125,   129,    89,  -211,
      89,    30,    30,  -211,  -211,    -6,  -211,    30,    30,   133,
     136,   138,  -211,  -211,  -211,  -211,  -211,  -211,  -211,  -211,
    -211,  -211,  -211,    91,    93,   141,    95,   145,   101,   134,
     153,   156,  -211,  -211,    89,     3,  -211,   157,   158,    -8,
      -4,   160,  -211,   159,   161,   162,  -211,  -211,   131,   123,
     163,  -211,   176,  -211,   168,  -211,  -211,  -211,   165,   177,
    -211,   170,   171,   172,   174,   175,  -211,    89,    89,    30,
      30,  -211,    89,    30,  -211,   110,   139,  -211,   -19,   164,
     178,   163,  -211,    89,  -211,  -211,   179,    89,    89,  -211,
    -211,    89,     6,   166,    30,  -211,   167,   181,   182,   114,
    -211,  -211,   137,   140,   144,  -211,    20,   146,  -211,   186,
    -211,    89,   118,    89,   189,   190,   192,   193,    89,    89,
    -211,  -211,  -211,    23,   139,   139,   155,   169,   173,  -211,
     180,  -211,  -211,  -211,  -211,  -211,   195,  -211,  -211,  -211,
    -211,    21,   194,  -211,    26,  -211,   183,   184,   139,   139,
    -211,   185,  -211,  -211,    89,    30,  -211,  -211,  -211,  -211,
     187,   188,    34,  -211,   196,   197,   139,   139,  -211,  -211,
    -211,   191,    34,  -211,  -211,  -211,   139,   139,   198,   199,
    -211
  };

  const signed char
  ECNFParser::yydefact_[] =
  {
       0,     0,     7,     0,   108,   107,     0,    20,     1,    11,
       8,     9,    10,    94,     0,    94,    94,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    62,    64,    34,    35,    27,
      28,    29,    31,    30,    21,    22,    23,    24,    25,    26,
      32,    33,     6,     0,    14,     4,    12,     0,     0,     0,
       0,     0,    94,     0,    94,     0,     0,     0,     0,   106,
       0,     0,     0,    94,    94,     0,   104,     0,     0,     0,
       0,     0,    66,    89,    43,    93,    94,    17,    11,    13,
      38,    39,    40,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   110,   109,     0,     0,   100,     0,     0,     0,
       0,     0,   103,     0,     0,     0,    36,    94,    69,    65,
      15,    94,    94,    41,     0,    50,    97,    51,     0,     0,
      44,     0,     0,     0,     0,     0,    99,     0,     0,   105,
     105,    60,     0,     0,    94,     0,     0,    67,    73,     0,
       0,    18,    42,     0,    95,    94,     0,     0,     0,    52,
      53,     0,     0,     0,   101,   102,     0,     0,     0,     0,
      37,    91,     0,     0,     0,    70,     0,     0,    16,     0,
      98,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      56,    57,    46,     0,     0,     0,     0,     0,     0,    74,
       0,    92,    90,    19,    96,    45,     0,    47,    48,    54,
      55,     0,     0,    82,    68,    81,     0,     0,     0,     0,
      85,     0,    63,    49,     0,     0,    80,    79,    83,    83,
       0,     0,    77,    85,     0,     0,    72,    71,    83,    83,
      86,     0,    78,    58,    59,    84,    76,    75,     0,    87,
      88
  };

  const short
  ECNFParser::yypgoto_[] =
  {
    -211,  -211,  -211,  -211,  -211,   121,  -211,  -211,  -211,  -211,
    -211,  -211,  -211,  -211,  -211,  -211,  -211,  -211,  -211,  -211,
    -211,  -211,  -211,  -211,  -211,  -211,  -211,  -211,  -211,  -211,
    -211,  -211,  -211,  -211,  -211,  -211,  -211,  -211,  -211,  -211,
    -210,   -23,  -211,  -134,  -211,    -7,  -211,  -211,  -211,  -130,
      72,   200,  -211,   -24,     9,   -66
  };

  const unsigned char
  ECNFParser::yydefgoto_[] =
  {
       0,     3,    14,    88,     7,    15,    56,    55,    86,   150,
     121,   179,    13,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    82,
      83,   118,   147,   148,   175,   176,   199,   200,   222,   214,
     236,   232,   119,   245,   202,    57,    96,   181,   153,   105,
     163,   164,   165,    76,    69,   106
  };

  const short
  ECNFParser::yytable_[] =
  {
      68,    70,   104,    85,     4,     5,    53,    85,   162,    58,
       6,    65,   172,   102,   103,     9,   102,   103,     8,   237,
      66,    -3,   173,   139,   174,   111,    54,   140,   246,   247,
      67,   102,   103,    -2,   135,   224,    79,   187,   134,   136,
       4,     5,    80,    81,    10,    11,    12,   107,   108,     1,
       2,   112,    59,   113,   114,    94,    61,    98,   211,   215,
     216,   217,   196,    60,   197,   198,   109,   110,    71,    72,
     171,   161,   213,   171,    62,   226,   167,    84,    85,   120,
     227,   171,    63,   240,   230,   231,    64,   180,    89,    85,
      73,   184,   185,    90,    85,   186,   136,    74,   241,   102,
     103,   123,   124,   125,    85,   127,   128,    77,   241,    78,
     145,   130,    85,    87,   151,   204,    91,   206,    92,   168,
     170,    85,    93,   212,   192,    85,    95,   -61,   205,    85,
      97,    16,    17,    18,    19,    20,    21,   169,   100,    22,
     112,    99,   101,    23,   115,   136,   116,   131,   182,   117,
      24,    25,    26,    27,    28,   126,   129,    29,   234,    30,
      31,    32,    33,    34,   132,    35,    36,   133,   137,   138,
     141,   146,   149,   142,    85,   143,    -5,   144,   152,   154,
     155,   156,   157,   158,   159,   160,   171,   193,   178,   194,
     183,   190,   191,   195,   201,   177,   203,   188,   189,   207,
     208,   235,   209,   210,   218,   223,   243,   244,   225,   122,
     242,     0,   166,     0,     0,     0,     0,     0,   219,     0,
       0,     0,     0,   220,     0,     0,   221,     0,     0,    75,
       0,     0,     0,   228,   229,   233,     0,   238,   239,     0,
       0,     0,   248,     0,     0,     0,     0,   249,     0,   250
  };

  const short
  ECNFParser::yycheck_[] =
  {
      24,    25,    68,    11,    10,    11,    13,    11,   138,    16,
       1,     3,   146,    10,    11,     6,    10,    11,     0,   229,
      12,    37,    41,    31,    43,    31,    37,    31,   238,   239,
      22,    10,    11,     0,    31,    14,    12,    31,   104,   105,
      10,    11,    33,    34,    19,    20,    21,    71,    72,    17,
      18,    75,    11,    77,    78,    62,    16,    64,   188,   193,
     194,   195,    42,    11,    44,    45,    73,    74,    23,    24,
      47,   137,    49,    47,    11,    49,   142,    10,    11,    86,
     214,    47,    11,    49,   218,   219,    11,   153,    10,    11,
      11,   157,   158,    10,    11,   161,   162,    11,   232,    10,
      11,    10,    11,    10,    11,    10,    11,    11,   242,    11,
     117,    10,    11,    37,   121,   181,    10,   183,    10,   143,
      10,    11,    11,   189,    10,    11,    11,     0,    10,    11,
      31,     4,     5,     6,     7,     8,     9,   144,    13,    12,
     164,    11,    13,    16,    11,   211,    10,    13,   155,    11,
      23,    24,    25,    26,    27,    14,    11,    30,   224,    32,
      33,    34,    35,    36,    11,    38,    39,    11,    11,    11,
      10,    40,    49,    14,    11,    14,     0,    15,    10,    14,
       3,    11,    11,    11,    10,    10,    47,    50,    10,    49,
      11,    10,    10,    49,    48,    31,    10,    31,    31,    10,
      10,   225,    10,    10,    49,    10,    10,    10,    14,    88,
     233,    -1,   140,    -1,    -1,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    -1,    50,    -1,    -1,    46,    -1,    -1,    29,
      -1,    -1,    -1,    50,    50,    50,    -1,    50,    50,    -1,
      -1,    -1,    51,    -1,    -1,    -1,    -1,    49,    -1,    50
  };

  const signed char
  ECNFParser::yystos_[] =
  {
       0,    17,    18,    53,    10,    11,   106,    56,     0,   106,
      19,    20,    21,    64,    54,    57,     4,     5,     6,     7,
       8,     9,    12,    16,    23,    24,    25,    26,    27,    30,
      32,    33,    34,    35,    36,    38,    39,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    97,    37,    59,    58,    97,    97,    11,
      11,    16,    11,    11,    11,     3,    12,    22,   105,   106,
     105,    23,    24,    11,    11,   103,   105,    11,    11,    12,
     106,   106,    81,    82,    10,    11,    60,    37,    55,    10,
      10,    10,    10,    11,    97,    11,    98,    31,    97,    11,
      13,    13,    10,    11,   107,   101,   107,   105,   105,    97,
      97,    31,   105,   105,   105,    11,    10,    11,    83,    94,
      97,    62,    57,    10,    11,    10,    14,    10,    11,    11,
      10,    13,    11,    11,   107,    31,   107,    11,    11,    31,
      31,    10,    14,    14,    15,    97,    40,    84,    85,    49,
      61,    97,    10,   100,    14,     3,    11,    11,    11,    10,
      10,   107,   101,   102,   103,   104,   102,   107,   105,    97,
      10,    47,    95,    41,    43,    86,    87,    31,    10,    63,
     107,    99,    97,    11,   107,   107,   107,    31,    31,    31,
      10,    10,    10,    50,    49,    49,    42,    44,    45,    88,
      89,    48,    96,    10,   107,    10,   107,    10,    10,    10,
      10,   101,   107,    49,    91,    95,    95,    95,    49,    49,
      50,    46,    90,    10,    14,    14,    49,    95,    50,    50,
      95,    95,    93,    50,   107,   105,    92,    92,    50,    50,
      49,    95,    93,    10,    10,    95,    92,    92,    51,    49,
      50
  };

  const signed char
  ECNFParser::yyr1_[] =
  {
       0,    52,    53,    54,    55,    53,    53,    56,    56,    56,
      56,    57,    57,    58,    60,    61,    59,    62,    63,    59,
      64,    64,    64,    64,    64,    64,    64,    64,    64,    64,
      64,    64,    64,    64,    64,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    73,    74,    75,    75,    75,
      76,    77,    78,    78,    78,    78,    79,    79,    79,    79,
      79,    80,    81,    80,    82,    80,    83,    83,    84,    85,
      85,    86,    86,    87,    87,    88,    88,    89,    90,    91,
      91,    91,    91,    92,    92,    93,    93,    93,    93,    94,
      94,    95,    96,    97,    97,    99,    98,   100,    98,   101,
     101,   102,   102,   103,   103,   104,   105,   106,   106,   107,
     107
  };

  const signed char
  ECNFParser::yyr2_[] =
  {
       0,     2,     4,     0,     0,     7,     4,     0,     2,     2,
       2,     0,     2,     2,     0,     0,     5,     0,     0,     6,
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     5,     3,     3,
       3,     4,     5,     2,     4,     7,     6,     7,     7,     8,
       4,     4,     5,     5,     7,     7,     6,     6,    10,    10,
       4,     0,     0,     7,     0,     3,     0,     2,     4,     0,
       2,     5,     5,     0,     2,     5,     5,     3,     3,     2,
       2,     1,     1,     0,     2,     0,     2,     4,     5,     0,
       4,     1,     1,     2,     0,     0,     5,     0,     4,     2,
       1,     1,     1,     2,     1,     0,     1,     1,     1,     1,
       1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const ECNFParser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "DEFOP",
  "SUBSETMINDEFN", "VARMINDEFN", "VARMAXDEFN", "AGGMINDEFN", "SETDEFN",
  "WSETDEFN", "ZERO", "NUMBER", "SEMDEFN", "SIGNDEFN", "REL", "IMPL",
  "AGGDEFN", "CNF", "ECNF", "DEFPRESENT", "AGGPRESENT", "MINIMPRESENT",
  "ORSEM", "INTVAR", "INTVARDOM", "PARTIAL", "CPSUM", "CPPROD", "ELEMENT",
  "COUNT", "DISTINCT", "DELIM", "BINTRI", "BINTRT", "IMPLICATION", "LEVEL",
  "SUBTHEORY", "QUANTe", "TRANSHEADER", "TRANSHEADER2", "TYPE", "PRED",
  "FUNC", "SHOWPRED", "SHOWFUNC", "TRUE", "ARBIT", "T_ID", "T_ID2",
  "T_NUM", "':'", "'/'", "$accept", "init", "$@1", "$@2", "header",
  "cnftheory", "cnfclause", "modalcnf", "$@3", "$@4", "$@5", "$@6",
  "ecnftheory", "level", "subtheory", "subsetmnmz", "varmnmz", "varmxmz",
  "aggmnmz", "summnmz", "clause", "rule", "implication", "agg", "set",
  "wset", "intvar", "cpconstraint", "translation", "$@7", "$@8",
  "typelist", "type", "predlist", "pred", "funclist", "func", "truelist",
  "arbitlist", "idnlist", "uint", "numlist", "tuplelist", "identifier",
  "identifier2", "body", "wbody", "$@9", "$@10", "weightbody",
  "possiblyemptyvaridbody", "varidbody", "emptyvaridbody", "varid",
  "number", "weight", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  ECNFParser::yyrline_[] =
  {
       0,   187,   187,   188,   188,   188,   194,   197,   198,   199,
     200,   205,   206,   209,   221,   222,   220,   224,   225,   223,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   250,   256,   268,   274,
     280,   286,   294,   301,   309,   321,   333,   341,   351,   357,
     367,   375,   385,   391,   397,   403,   419,   425,   431,   437,
     444,   454,   456,   455,   463,   462,   470,   471,   474,   477,
     478,   481,   482,   485,   486,   489,   490,   493,   496,   499,
     500,   501,   502,   505,   506,   509,   510,   511,   512,   515,
     516,   519,   522,   530,   531,   535,   534,   544,   543,   554,
     555,   558,   559,   562,   563,   566,   568,   575,   576,   578,
     579
  };

  void
  ECNFParser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  ECNFParser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  ECNFParser::symbol_kind_type
  ECNFParser::yytranslate_ (int t) YY_NOEXCEPT
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const signed char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    51,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    50,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49
    };
    // Last valid token kind.
    const int code_max = 304;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return static_cast <symbol_kind_type> (translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

#line 16 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"
} // MinisatID
#line 1939 "/builddir/build/BUILD/idp/redhat-linux-build/lib/minisatid/src/ecnfparser/ecnfparser.cc"

#line 581 "/builddir/build/BUILD/idp/lib/minisatid/src/parser/ecnfparser.ypp"


int ecnfwrap() {
	clog << "End of file reached before it was expected... bailing out.\n";
	return 1;
}

void checkVersion(ECNF_VERSION version){
	if(currentreadversion == VERSION_NONE){
		currentreadversion = version;
	}
	if(currentreadversion != version){
		throw idpexception("Cannot combine previous ecnf format with the new one "
				"(using rules/aggregates with and without definition id).\n");
	}
}

Atom cAtom(string* c){
	int i = atoi(c->c_str());
	if(i<0){
		throw idpexception("Negative number supplied where an atom was suspected.\n");
	}
	return Atom(i);
}

uint cID(string* c){
	int i = atoi(c->c_str());
	if(i<1){
		throw idpexception("IDs have to be non-negative nonzero integers.\n");
	}
	return i;
}
VarID cVarID(string* c){
	return {cID(c)};
}

Lit cLiteral(string* c){
	int i = atoi(c->c_str());
	return mkLit(abs(i), i<0);
}

Weight cWeight(string* s){
	const char* c = s->c_str();
	Weight w(0);
	bool begin = true, negate = false;
	for(int i = 0; c[i] != '\0'; ++i) {
	    if(begin && c[i]=='-'){
	    	negate = true;
	    	begin = false;
	    	continue;
	    }
#ifdef NOARBITPREC
		if(posInfinity()/10 < w){
			throw idpexception("Weight exceeds the maximum supported value. Consider using GMP.\n");
		}
#endif
	    w = w*10 + (c[i]-48);
	}
	if(negate){
		w *= -1;
	}
	return w;
}

/**
 * CR-CheckResult: checks the result of passing some data to the solvers.
 * The result is false if unsat was already detected.
 */
template<class Wrapper, class T>
void CR(Wrapper* wrapper, T& formula, TheoryID level){
	formula.theoryid = level;
	extAdd(*wrapper, formula);
	if(wrapper->isCertainlyUnsat()){
		throw idpexception("Unsat during parsing.\n");
	}
}

void addTuple(int literalnumber, const string& atom) {
	if(simpletrans!=NULL){
		simpletrans->setString(Atom(literalnumber), atom);
	}
}

void parsetruelist(vector<int>* literalnumbers) {
	if(fodottrans!=NULL){
		fodottrans->setTruelist(*literalnumbers);
	}
}

void parsearbitlist(vector<int>* literalnumbers) {
	if(fodottrans!=NULL){
		fodottrans->setArbitlist(*literalnumbers);
	}
}

void parsetype(string* name, vector<string>* inter) {
	if(fodottrans!=NULL){
		fodottrans->addType(*name, *inter);
	}
}

void parsepred(string* name, int startingnumber, vector<string>* argtypes, bool isfunction) {
	if(fodottrans!=NULL){
		fodottrans->addPred(*name, startingnumber, *argtypes, isfunction);
	}
}

template<class Wrapper>
void readCNFModalHierLevel(Wrapper* wrapper, bool existential, const vector<Lit>& rigidlits, TheoryID& level, bool& negatemod, int& maxatom){
	bool writeexists;
	if(existential && negatemod){
		negatemod = false;
		writeexists = false;
	}else if(existential && !negatemod){
		negatemod = false;
		writeexists = true;
	}else if(!existential && negatemod){
		negatemod = true;
		writeexists = true;
	}else{
		negatemod = true;
		writeexists = false;
	}
		
	if(level.id==1){
		if(not existential){
			throw idpexception("First QBF level cannot be universal.\n");
		}
		level = TheoryID(level.id+1);		
		return;
	}
	if(level.id==2){
		auto trans = new QBFTranslator();
		wrapper->setTranslator(trans);
		for(auto lit:rigidlits){
			stringstream ss;
			ss <<lit.getAtom();
			trans->setString(lit.getAtom(), ss.str());
		}
	}
	
	auto lastlevel = TheoryID(level.id-1);
	
	if(rigidlits.size()==0){
		throw idpexception("List of rigid atoms is empty.\n");
	}	
	
	auto head = ++maxatom;
	if(writeexists){
		Disjunction disj({mkPosLit(head)});
		CR(wrapper, disj, lastlevel);
		head = ~head;
	}else{
		Disjunction disj({mkNegLit(head)});
		CR(wrapper, disj, lastlevel);
	}
	std::vector<Atom> atoms;
	for(auto lit:rigidlits){
		atoms.push_back(lit.getAtom());
	}
	SubTheory sub(head, level, atoms);
	CR(wrapper, sub, lastlevel);
	level = TheoryID(level.id+1);
}

// We have to implement the error function
void MinisatID::ECNFParser::error(const MinisatID::ECNFParser::location_type&, const std::string &msg) {
	std::stringstream ss;
	ss << "Error: " << msg << std::endl;
	throw idpexception(ss.str());
}

// Now that we have the Parser declared, we can declare the Scanner and implement
// the yylex function
#include "parser/ECNFScanner.hpp"
static int ecnflex(MinisatID::ECNFParser::semantic_type * yylval, MinisatID::ECNFParser::location_type * yyloc, MinisatID::ECNFScanner &scanner) {
	return scanner.ecnflex(yylval, yyloc);
}
