/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 9 "/builddir/build/BUILD/idp/src/parser/parser.yy"


#include <sstream>
#include "GlobalData.hpp"
#include "common.hpp"
#include "errorhandling/error.hpp"
#include "insert.hpp"
#include "theory/term.hpp" // Necessary for inheritance tree
#include "theory/Sets.hpp"
#include "parser/yyltype.hpp"

// Lexer
extern int yylex();

Insert& data();

std::string getInstalledFilePath(std::string filename);

// Errors
void yyerror(const char* s);

# define YYLLOC_DEFAULT(Current, Rhs, N)									 \
         do                                                                  \
           if (N)                                                            \
             {                                                               \
               (Current).first_line   = YYRHSLOC(Rhs, 1).first_line;         \
               (Current).first_column = YYRHSLOC(Rhs, 1).first_column;       \
               (Current).last_line    = YYRHSLOC(Rhs, N).last_line;          \
               (Current).last_column  = YYRHSLOC(Rhs, N).last_column;        \
			   (Current).descr		  = YYRHSLOC(Rhs, 1).descr;				 \
             }                                                               \
           else                                                              \
             {                                                               \
               (Current).first_line   = (Current).last_line   =              \
                 YYRHSLOC(Rhs, 0).last_line;                                 \
               (Current).first_column = (Current).last_column =              \
                 YYRHSLOC(Rhs, 0).last_column;                               \
			   (Current).descr		  = YYRHSLOC(Rhs,0).descr;				 \
             }                                                               \
         while (0)


#line 114 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_VOCAB_HEADER = 3,               /* VOCAB_HEADER  */
  YYSYMBOL_LTC_VOCAB_HEADER = 4,           /* LTC_VOCAB_HEADER  */
  YYSYMBOL_DEF_HEADER = 5,                 /* DEF_HEADER  */
  YYSYMBOL_THEORY_HEADER = 6,              /* THEORY_HEADER  */
  YYSYMBOL_STRUCT_HEADER = 7,              /* STRUCT_HEADER  */
  YYSYMBOL_ASP_HEADER = 8,                 /* ASP_HEADER  */
  YYSYMBOL_NAMESPACE_HEADER = 9,           /* NAMESPACE_HEADER  */
  YYSYMBOL_PROCEDURE_HEADER = 10,          /* PROCEDURE_HEADER  */
  YYSYMBOL_QUERY_HEADER = 11,              /* QUERY_HEADER  */
  YYSYMBOL_FOBDD_HEADER = 12,              /* FOBDD_HEADER  */
  YYSYMBOL_TERM_HEADER = 13,               /* TERM_HEADER  */
  YYSYMBOL_CONSTRUCTOR = 14,               /* CONSTRUCTOR  */
  YYSYMBOL_PROCEDURE = 15,                 /* PROCEDURE  */
  YYSYMBOL_PARTIAL = 16,                   /* PARTIAL  */
  YYSYMBOL_EXTENDS = 17,                   /* EXTENDS  */
  YYSYMBOL_EXTERN = 18,                    /* EXTERN  */
  YYSYMBOL_P_MINAGG = 19,                  /* P_MINAGG  */
  YYSYMBOL_P_MAXAGG = 20,                  /* P_MAXAGG  */
  YYSYMBOL_P_CARD = 21,                    /* P_CARD  */
  YYSYMBOL_P_PROD = 22,                    /* P_PROD  */
  YYSYMBOL_P_SOM = 23,                     /* P_SOM  */
  YYSYMBOL_FALSE = 24,                     /* FALSE  */
  YYSYMBOL_USINGVOCABULARY = 25,           /* USINGVOCABULARY  */
  YYSYMBOL_EXTERNVOCABULARY = 26,          /* EXTERNVOCABULARY  */
  YYSYMBOL_USINGNAMESPACE = 27,            /* USINGNAMESPACE  */
  YYSYMBOL_TYPE = 28,                      /* TYPE  */
  YYSYMBOL_TRUE = 29,                      /* TRUE  */
  YYSYMBOL_ABS = 30,                       /* ABS  */
  YYSYMBOL_ISA = 31,                       /* ISA  */
  YYSYMBOL_CONSTRUCTED = 32,               /* CONSTRUCTED  */
  YYSYMBOL_LFD = 33,                       /* LFD  */
  YYSYMBOL_GFD = 34,                       /* GFD  */
  YYSYMBOL_NEWLINE = 35,                   /* NEWLINE  */
  YYSYMBOL_LUAVARARG = 36,                 /* LUAVARARG  */
  YYSYMBOL_IN = 37,                        /* IN  */
  YYSYMBOL_SAT = 38,                       /* SAT  */
  YYSYMBOL_TRUEBRANCH = 39,                /* TRUEBRANCH  */
  YYSYMBOL_FALSEBRANCH = 40,               /* FALSEBRANCH  */
  YYSYMBOL_EXISTS = 41,                    /* EXISTS  */
  YYSYMBOL_INTEGER = 42,                   /* INTEGER  */
  YYSYMBOL_FLNUMBER = 43,                  /* FLNUMBER  */
  YYSYMBOL_CHARACTER = 44,                 /* CHARACTER  */
  YYSYMBOL_CHARCONS = 45,                  /* CHARCONS  */
  YYSYMBOL_IDENTIFIER = 46,                /* IDENTIFIER  */
  YYSYMBOL_STRINGCONS = 47,                /* STRINGCONS  */
  YYSYMBOL_LUACHUNK = 48,                  /* LUACHUNK  */
  YYSYMBOL_MAPS = 49,                      /* "->"  */
  YYSYMBOL_EQUIV = 50,                     /* "<=>"  */
  YYSYMBOL_P_IMPL = 51,                    /* "=>"  */
  YYSYMBOL_P_RIMPL = 52,                   /* "<="  */
  YYSYMBOL_DEFIMP = 53,                    /* "<-"  */
  YYSYMBOL_P_NEQ = 54,                     /* "~="  */
  YYSYMBOL_P_EQ = 55,                      /* "=="  */
  YYSYMBOL_P_LEQ = 56,                     /* "=<"  */
  YYSYMBOL_P_GEQ = 57,                     /* ">="  */
  YYSYMBOL_RANGE = 58,                     /* ".."  */
  YYSYMBOL_NSPACE = 59,                    /* "::"  */
  YYSYMBOL_60_ = 60,                       /* ':'  */
  YYSYMBOL_61_ = 61,                       /* '|'  */
  YYSYMBOL_62_ = 62,                       /* '&'  */
  YYSYMBOL_63_ = 63,                       /* '~'  */
  YYSYMBOL_64_ = 64,                       /* '-'  */
  YYSYMBOL_65_ = 65,                       /* '+'  */
  YYSYMBOL_66_ = 66,                       /* '/'  */
  YYSYMBOL_67_ = 67,                       /* '*'  */
  YYSYMBOL_68_ = 68,                       /* '%'  */
  YYSYMBOL_69_ = 69,                       /* '^'  */
  YYSYMBOL_UMINUS = 70,                    /* UMINUS  */
  YYSYMBOL_71_ = 71,                       /* '{'  */
  YYSYMBOL_72_ = 72,                       /* '}'  */
  YYSYMBOL_73_ = 73,                       /* '('  */
  YYSYMBOL_74_ = 74,                       /* ','  */
  YYSYMBOL_75_ = 75,                       /* ')'  */
  YYSYMBOL_76_ = 76,                       /* '['  */
  YYSYMBOL_77_ = 77,                       /* ']'  */
  YYSYMBOL_78_ = 78,                       /* '='  */
  YYSYMBOL_79_ = 79,                       /* '.'  */
  YYSYMBOL_80_ = 80,                       /* '!'  */
  YYSYMBOL_81_ = 81,                       /* '?'  */
  YYSYMBOL_82_ = 82,                       /* '<'  */
  YYSYMBOL_83_ = 83,                       /* '>'  */
  YYSYMBOL_84_ = 84,                       /* ';'  */
  YYSYMBOL_YYACCEPT = 85,                  /* $accept  */
  YYSYMBOL_idp = 86,                       /* idp  */
  YYSYMBOL_namespace = 87,                 /* namespace  */
  YYSYMBOL_namespace_name = 88,            /* namespace_name  */
  YYSYMBOL_using = 89,                     /* using  */
  YYSYMBOL_vocabulary = 90,                /* vocabulary  */
  YYSYMBOL_vocab_name = 91,                /* vocab_name  */
  YYSYMBOL_vocab_pointer = 92,             /* vocab_pointer  */
  YYSYMBOL_vocab_content = 93,             /* vocab_content  */
  YYSYMBOL_94_1 = 94,                      /* $@1  */
  YYSYMBOL_symbol_declaration = 95,        /* symbol_declaration  */
  YYSYMBOL_extern_symbol = 96,             /* extern_symbol  */
  YYSYMBOL_extern_sort = 97,               /* extern_sort  */
  YYSYMBOL_extern_predicate = 98,          /* extern_predicate  */
  YYSYMBOL_extern_function = 99,           /* extern_function  */
  YYSYMBOL_sort_decl = 100,                /* sort_decl  */
  YYSYMBOL_101_2 = 101,                    /* $@2  */
  YYSYMBOL_pred_decl = 102,                /* pred_decl  */
  YYSYMBOL_func_decl = 103,                /* func_decl  */
  YYSYMBOL_full_func_decl = 104,           /* full_func_decl  */
  YYSYMBOL_constr_func_decl = 105,         /* constr_func_decl  */
  YYSYMBOL_sort_pointer = 106,             /* sort_pointer  */
  YYSYMBOL_intern_pointer = 107,           /* intern_pointer  */
  YYSYMBOL_pointer_name = 108,             /* pointer_name  */
  YYSYMBOL_namedquery = 109,               /* namedquery  */
  YYSYMBOL_query_name = 110,               /* query_name  */
  YYSYMBOL_query = 111,                    /* query  */
  YYSYMBOL_query_vars = 112,               /* query_vars  */
  YYSYMBOL_namedfobdd = 113,               /* namedfobdd  */
  YYSYMBOL_fobdd_name = 114,               /* fobdd_name  */
  YYSYMBOL_fobdd = 115,                    /* fobdd  */
  YYSYMBOL_kernel = 116,                   /* kernel  */
  YYSYMBOL_namedterm = 117,                /* namedterm  */
  YYSYMBOL_term_name = 118,                /* term_name  */
  YYSYMBOL_theory = 119,                   /* theory  */
  YYSYMBOL_theory_name = 120,              /* theory_name  */
  YYSYMBOL_def_forms = 121,                /* def_forms  */
  YYSYMBOL_definition = 122,               /* definition  */
  YYSYMBOL_rules = 123,                    /* rules  */
  YYSYMBOL_rule = 124,                     /* rule  */
  YYSYMBOL_univquantvars = 125,            /* univquantvars  */
  YYSYMBOL_head = 126,                     /* head  */
  YYSYMBOL_fixpdef = 127,                  /* fixpdef  */
  YYSYMBOL_fd_rules = 128,                 /* fd_rules  */
  YYSYMBOL_formula = 129,                  /* formula  */
  YYSYMBOL_predicate = 130,                /* predicate  */
  YYSYMBOL_eq_chain = 131,                 /* eq_chain  */
  YYSYMBOL_variablelist = 132,             /* variablelist  */
  YYSYMBOL_variables = 133,                /* variables  */
  YYSYMBOL_variable = 134,                 /* variable  */
  YYSYMBOL_theosort_pointer = 135,         /* theosort_pointer  */
  YYSYMBOL_term = 136,                     /* term  */
  YYSYMBOL_function = 137,                 /* function  */
  YYSYMBOL_atomarterm = 138,               /* atomarterm  */
  YYSYMBOL_nonatomarterm = 139,            /* nonatomarterm  */
  YYSYMBOL_arterm = 140,                   /* arterm  */
  YYSYMBOL_domterm = 141,                  /* domterm  */
  YYSYMBOL_aggterm = 142,                  /* aggterm  */
  YYSYMBOL_formlist = 143,                 /* formlist  */
  YYSYMBOL_formset = 144,                  /* formset  */
  YYSYMBOL_termlist = 145,                 /* termlist  */
  YYSYMBOL_termset = 146,                  /* termset  */
  YYSYMBOL_structure = 147,                /* structure  */
  YYSYMBOL_struct_name = 148,              /* struct_name  */
  YYSYMBOL_interpretations = 149,          /* interpretations  */
  YYSYMBOL_interpretation = 150,           /* interpretation  */
  YYSYMBOL_empty_inter = 151,              /* empty_inter  */
  YYSYMBOL_sort_inter = 152,               /* sort_inter  */
  YYSYMBOL_elements_es = 153,              /* elements_es  */
  YYSYMBOL_elements = 154,                 /* elements  */
  YYSYMBOL_func_list = 155,                /* func_list  */
  YYSYMBOL_strelement = 156,               /* strelement  */
  YYSYMBOL_pred_inter = 157,               /* pred_inter  */
  YYSYMBOL_ptuples_es = 158,               /* ptuples_es  */
  YYSYMBOL_ptuples = 159,                  /* ptuples  */
  YYSYMBOL_emptyptuple = 160,              /* emptyptuple  */
  YYSYMBOL_ptuple = 161,                   /* ptuple  */
  YYSYMBOL_pelement = 162,                 /* pelement  */
  YYSYMBOL_func_inter = 163,               /* func_inter  */
  YYSYMBOL_ftuples_es = 164,               /* ftuples_es  */
  YYSYMBOL_ftuples = 165,                  /* ftuples  */
  YYSYMBOL_ftuple = 166,                   /* ftuple  */
  YYSYMBOL_f3tuples_es = 167,              /* f3tuples_es  */
  YYSYMBOL_f3tuples = 168,                 /* f3tuples  */
  YYSYMBOL_proc_inter = 169,               /* proc_inter  */
  YYSYMBOL_three_inter = 170,              /* three_inter  */
  YYSYMBOL_threeempty_inter = 171,         /* threeempty_inter  */
  YYSYMBOL_threepred_inter = 172,          /* threepred_inter  */
  YYSYMBOL_threefunc_inter = 173,          /* threefunc_inter  */
  YYSYMBOL_intrange = 174,                 /* intrange  */
  YYSYMBOL_charrange = 175,                /* charrange  */
  YYSYMBOL_compound = 176,                 /* compound  */
  YYSYMBOL_compound_args = 177,            /* compound_args  */
  YYSYMBOL_integer = 178,                  /* integer  */
  YYSYMBOL_floatnr = 179,                  /* floatnr  */
  YYSYMBOL_identifier = 180,               /* identifier  */
  YYSYMBOL_asp_structure = 181,            /* asp_structure  */
  YYSYMBOL_atoms = 182,                    /* atoms  */
  YYSYMBOL_predatom = 183,                 /* predatom  */
  YYSYMBOL_domain_tuple = 184,             /* domain_tuple  */
  YYSYMBOL_domain_element = 185,           /* domain_element  */
  YYSYMBOL_term_tuple = 186,               /* term_tuple  */
  YYSYMBOL_sort_pointer_tuple = 187,       /* sort_pointer_tuple  */
  YYSYMBOL_nonempty_spt = 188,             /* nonempty_spt  */
  YYSYMBOL_instructions = 189,             /* instructions  */
  YYSYMBOL_proc_name = 190,                /* proc_name  */
  YYSYMBOL_proc_sig = 191,                 /* proc_sig  */
  YYSYMBOL_args = 192                      /* args  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1719

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  85
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  108
/* YYNRULES -- Number of rules.  */
#define YYNRULES  339
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  696

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   315


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    80,     2,     2,     2,    68,    62,     2,
      73,    75,    67,    65,    74,    64,    79,    66,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    60,    84,
      82,    78,    83,    81,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    76,     2,    77,    69,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    71,    61,    72,    63,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    70
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   247,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   260,   263,   266,   267,   277,   279,   282,
     286,   289,   292,   293,   294,   295,   296,   296,   297,   300,
     301,   302,   305,   306,   307,   310,   313,   315,   319,   322,
     327,   328,   330,   332,   334,   336,   336,   338,   340,   342,
     344,   346,   350,   351,   354,   355,   358,   360,   363,   364,
     370,   373,   375,   378,   382,   383,   390,   393,   396,   399,
     400,   406,   408,   410,   411,   412,   414,   415,   416,   426,
     429,   436,   439,   442,   443,   444,   445,   446,   451,   452,
     454,   455,   458,   459,   462,   463,   464,   468,   469,   472,
     473,   479,   480,   483,   484,   485,   486,   490,   492,   494,
     500,   506,   507,   508,   510,   512,   514,   516,   518,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     533,   534,   535,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   551,   552,   553,   555,   556,
     557,   560,   561,   564,   569,   570,   573,   574,   575,   578,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   600,   601,   604,
     605,   606,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   624,   625,   628,   629,   632,   633,   636,   637,
     645,   648,   651,   652,   653,   656,   657,   658,   659,   660,
     661,   666,   671,   674,   675,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   690,   692,   693,   694,
     695,   696,   697,   698,   699,   703,   704,   705,   709,   710,
     711,   716,   717,   718,   721,   722,   725,   726,   727,   728,
     729,   730,   733,   736,   737,   741,   742,   743,   744,   745,
     746,   751,   752,   755,   758,   759,   762,   763,   766,   767,
     768,   769,   772,   773,   776,   777,   782,   787,   788,   789,
     792,   795,   796,   797,   798,   801,   802,   810,   812,   813,
     818,   819,   822,   823,   824,   825,   826,   827,   828,   829,
     834,   835,   838,   839,   842,   843,   844,   845,   852,   855,
     856,   857,   858,   861,   862,   863,   866,   867,   868,   869,
     870,   871,   874,   875,   876,   877,   880,   881,   884,   885,
     888,   889,   897,   900,   903,   904,   907,   908,   909,   910
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "VOCAB_HEADER",
  "LTC_VOCAB_HEADER", "DEF_HEADER", "THEORY_HEADER", "STRUCT_HEADER",
  "ASP_HEADER", "NAMESPACE_HEADER", "PROCEDURE_HEADER", "QUERY_HEADER",
  "FOBDD_HEADER", "TERM_HEADER", "CONSTRUCTOR", "PROCEDURE", "PARTIAL",
  "EXTENDS", "EXTERN", "P_MINAGG", "P_MAXAGG", "P_CARD", "P_PROD", "P_SOM",
  "FALSE", "USINGVOCABULARY", "EXTERNVOCABULARY", "USINGNAMESPACE", "TYPE",
  "TRUE", "ABS", "ISA", "CONSTRUCTED", "LFD", "GFD", "NEWLINE",
  "LUAVARARG", "IN", "SAT", "TRUEBRANCH", "FALSEBRANCH", "EXISTS",
  "INTEGER", "FLNUMBER", "CHARACTER", "CHARCONS", "IDENTIFIER",
  "STRINGCONS", "LUACHUNK", "\"->\"", "\"<=>\"", "\"=>\"", "\"<=\"",
  "\"<-\"", "\"~=\"", "\"==\"", "\"=<\"", "\">=\"", "\"..\"", "\"::\"",
  "':'", "'|'", "'&'", "'~'", "'-'", "'+'", "'/'", "'*'", "'%'", "'^'",
  "UMINUS", "'{'", "'}'", "'('", "','", "')'", "'['", "']'", "'='", "'.'",
  "'!'", "'?'", "'<'", "'>'", "';'", "$accept", "idp", "namespace",
  "namespace_name", "using", "vocabulary", "vocab_name", "vocab_pointer",
  "vocab_content", "$@1", "symbol_declaration", "extern_symbol",
  "extern_sort", "extern_predicate", "extern_function", "sort_decl", "$@2",
  "pred_decl", "func_decl", "full_func_decl", "constr_func_decl",
  "sort_pointer", "intern_pointer", "pointer_name", "namedquery",
  "query_name", "query", "query_vars", "namedfobdd", "fobdd_name", "fobdd",
  "kernel", "namedterm", "term_name", "theory", "theory_name", "def_forms",
  "definition", "rules", "rule", "univquantvars", "head", "fixpdef",
  "fd_rules", "formula", "predicate", "eq_chain", "variablelist",
  "variables", "variable", "theosort_pointer", "term", "function",
  "atomarterm", "nonatomarterm", "arterm", "domterm", "aggterm",
  "formlist", "formset", "termlist", "termset", "structure", "struct_name",
  "interpretations", "interpretation", "empty_inter", "sort_inter",
  "elements_es", "elements", "func_list", "strelement", "pred_inter",
  "ptuples_es", "ptuples", "emptyptuple", "ptuple", "pelement",
  "func_inter", "ftuples_es", "ftuples", "ftuple", "f3tuples_es",
  "f3tuples", "proc_inter", "three_inter", "threeempty_inter",
  "threepred_inter", "threefunc_inter", "intrange", "charrange",
  "compound", "compound_args", "integer", "floatnr", "identifier",
  "asp_structure", "atoms", "predatom", "domain_tuple", "domain_element",
  "term_tuple", "sort_pointer_tuple", "nonempty_spt", "instructions",
  "proc_name", "proc_sig", "args", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-585)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-261)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -585,  1559,  -585,  1029,  1029,  1029,  1029,  1029,  1029,  1029,
    1029,  1029,  1029,  1029,  1029,  -585,  -585,  -585,  -585,  -585,
    -585,  -585,  -585,  -585,  -585,  -585,  -585,  -585,  -585,   -56,
    -585,    64,   -42,  -585,   -36,  -585,    24,     6,  -585,  -585,
      38,    31,  -585,    65,  -585,    69,  -585,    86,  -585,    86,
    -585,  -585,  1029,  1029,  1029,  1029,  -585,   446,    92,  1029,
    1029,  1029,  1029,   745,   770,   104,   -21,   139,    86,   157,
     164,   622,  -585,  -585,  -585,   107,   190,   175,   194,   206,
    -585,  1029,   495,  1029,  1029,  -585,  -585,   162,   277,  -585,
    -585,  -585,  -585,    33,  -585,  1029,  1029,  -585,  -585,  -585,
    -585,   741,  -585,  -585,   257,  1143,  1176,  -585,   149,  1029,
     319,  -585,  -585,  -585,   213,    86,    35,  -585,  -585,  1029,
    1029,   297,  -585,    86,   109,   301,   866,   286,   442,  -585,
    -585,  -585,   310,    70,   152,   197,   233,   237,  -585,  -585,
     313,  1029,  -585,  -585,  -585,  -585,  1209,   342,   358,   360,
     362,   365,  1242,  1438,   370,   412,  -585,   137,   210,  -585,
    -585,  -585,   343,  -585,  -585,   384,   390,  1029,  -585,  -585,
     426,  1029,   436,  1029,  1029,   410,   453,  -585,   418,  1029,
    1029,  -585,  1029,   428,  -585,  -585,   432,   434,   984,   431,
    -585,   984,   261,   787,  -585,  -585,  -585,   289,  -585,   137,
    -585,  -585,     1,  -585,  -585,  -585,  -585,  -585,  -585,  -585,
    -585,  -585,  -585,  -585,  -585,   440,   202,   550,  -585,   790,
    1176,  -585,  1176,  -585,   973,   984,  -585,  1176,  -585,  1176,
    -585,  1242,   447,   449,  1242,  -585,  1242,  1242,  1242,  1242,
    1242,   460,   343,  1039,  -585,  1143,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1242,  1242,
    1242,  1242,  1242,  1242,  1079,  -585,   465,   462,   127,  -585,
      14,     8,  1413,   488,   501,   514,   518,  -585,   541,   198,
     198,  -585,  -585,   544,  -585,   180,   414,  1029,   376,  -585,
    1029,   564,   575,  1029,   578,   579,   581,   500,   984,   984,
     984,   984,   984,  -585,   505,  1029,   934,  -585,  -585,   984,
    -585,   984,   801,  -585,   247,   262,   984,  1095,   591,   299,
     304,   316,  1355,  1143,  1029,   854,   888,  1484,  1623,  1634,
    1645,  -585,  1458,  -585,   320,   597,  -585,  -585,  -585,  -585,
    -585,  -585,  -585,  -585,  -585,  -585,  -585,  -585,   637,   637,
     355,   355,   568,   568,  -585,   366,   501,   602,  1029,  -585,
    1029,  1029,  -585,  -585,   587,   590,  -585,   435,  1536,   566,
     583,   586,  -585,  -585,  -585,  -585,   604,  -585,   154,  1029,
    1029,   605,  -585,  -585,   606,   598,  -585,    10,    17,  -585,
    -585,  1029,    18,  -585,   617,  -585,   540,  -585,   984,  1029,
    -585,  1286,  1029,  1029,   700,  1029,  1029,  1029,   984,   591,
     308,    53,   466,   634,  -585,  1029,  -585,  -585,  -585,  -585,
    1354,  -585,  -585,  -585,  -585,   154,   624,  -585,  -585,  -585,
    -585,  -585,   604,  -585,   456,  -585,   444,   621,   984,  1176,
    -585,  -585,   531,   984,   984,  -585,  -585,  -585,  -585,   638,
      86,   636,  1242,  1242,  1242,  1242,  1242,  1242,  1176,  1478,
    1143,  -585,  -585,   641,   301,   301,   676,   677,  -585,  -585,
    -585,   646,   648,   649,   650,   999,    11,  1424,     5,  -585,
     259,   656,  -585,  -585,  -585,  -585,  -585,   660,  -585,  -585,
    1291,   921,  -585,  1176,  1029,   516,  -585,   591,  -585,   984,
    1296,  1311,   519,  1315,  1330,  1335,   591,    86,    90,    60,
    1550,  -585,  1252,   668,   669,   658,   694,    68,   118,   673,
     672,  -585,   126,    91,   131,    46,   675,  1561,  -585,  -585,
    1176,  1028,  -585,  -585,   855,   591,  -585,  -585,  1551,  1563,
    1575,  1587,  1599,  1611,  -585,  -585,  -585,  -585,  -585,  -585,
    -585,  -585,  -585,  -585,  -585,  -585,   490,  -585,  -585,  1029,
    1029,  1536,  -585,  -585,  -585,  -585,   604,  -585,   715,  -585,
    -585,  1029,  1029,  1133,  -585,  -585,  -585,   305,  -585,  -585,
    1029,   984,   591,   984,   984,  1029,   984,   984,   984,   984,
    -585,   684,  -585,   534,   686,   648,   649,   650,  -585,  -585,
    1437,  1550,  1550,  1550,  1550,  1550,  -585,  1400,   655,  -585,
    -585,  -585,   693,  1176,  -585,  -585,  -585,  -585,  -585,  -585,
    -585,  1536,  -585,    22,    16,   691,   701,   706,   709,  -585,
     717,  -585,  -585,   733,  1068,   591,   591,   734,  1141,   591,
     591,   591,  -585,  1275,  -585,   695,  -585,  -585,  -585,  -585,
    -585,   724,   694,    68,  -585,  -585,  -585,  1368,  -585,  -585,
     737,  -585,  -585,  -585,  -585,  1029,  1029,  -585,  -585,  -585,
    -585,  -585,   984,   984,   984,   984,   537,  -585,   738,   739,
    -585,   740,   722,  -585,   301,   301,   591,   591,   591,   591,
    -585,  -585,  -585,  -585,  1400,  -585
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     1,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     3,    12,     4,     9,    10,
      11,     5,     6,     7,     8,   306,   307,   305,   304,     0,
      20,     0,     0,    82,     0,   201,     0,     0,    14,   333,
       0,     0,    67,     0,    72,     0,    80,    16,    65,    15,
      22,    22,     0,     0,     0,     0,     2,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    63,     0,    21,     0,
       0,     0,   339,   334,   338,     0,     0,     0,     0,     0,
      64,     0,     0,     0,     0,    23,    17,     0,     0,    29,
      30,    31,    55,    53,    18,     0,   328,    83,   202,   309,
      13,     0,   335,   332,     0,     0,     0,    54,     0,     0,
       0,    32,    33,    34,     0,    26,    40,    28,    24,     0,
     328,     0,   331,    60,     0,   329,     0,     0,     0,   337,
     336,    69,     0,     0,     0,     0,     0,     0,    75,    74,
       0,     0,   175,   179,   181,   180,     0,     0,     0,     0,
       0,     0,     0,   130,     0,     0,    76,    77,     0,   159,
     177,   178,   154,   155,   176,   158,     0,   328,    35,    25,
       0,   328,     0,     0,     0,     0,     0,    57,     0,     0,
       0,    61,     0,     0,   127,   126,     0,     0,     0,    98,
      81,     0,     0,     0,    87,    84,    86,     0,   129,   128,
     200,   204,     0,   203,   205,   206,   207,   208,   209,   210,
     279,   277,   278,   308,   312,   315,     0,     0,    66,     0,
       0,   189,     0,   191,     0,     0,   183,     0,   187,     0,
     185,     0,     0,   151,     0,   172,     0,     0,     0,     0,
       0,   178,     0,     0,    71,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    79,     0,    37,     0,    27,
      42,    41,     0,     0,    52,     0,     0,   330,    98,    98,
      98,   119,    90,    98,    93,     0,     0,     0,     0,   150,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    85,     0,     0,     0,   310,   311,     0,
      70,     0,     0,   197,     0,     0,     0,     0,   193,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   131,   327,     0,     0,   134,   137,   138,   133,
     135,   136,   140,   143,   144,   139,   141,   142,   160,   162,
     166,   164,   168,   170,   157,     0,     0,     0,     0,    36,
       0,     0,   300,   302,   305,   240,   239,     0,     0,     0,
       0,   214,   231,   226,   225,   234,   232,   233,   238,   237,
       0,     0,    62,    91,    98,     0,   106,    98,    98,    88,
      92,     0,     0,    99,     0,   125,     0,   147,     0,     0,
     148,     0,     0,     0,     0,     0,     0,     0,     0,   124,
     122,   123,   121,   120,   263,     0,   243,   242,   257,   258,
       0,   262,   260,   255,   259,   256,     0,   314,   322,   320,
     321,   325,   323,   324,     0,   319,     0,     0,     0,     0,
     188,   190,     0,     0,     0,   182,   186,   184,   173,     0,
     153,     0,     0,     0,     0,     0,     0,     0,     0,   132,
       0,   156,    39,     0,    44,    43,     0,     0,   301,   303,
     240,     0,     0,     0,     0,     0,    47,   213,     0,   236,
       0,    59,    56,    22,    89,   105,   101,     0,   104,   102,
       0,     0,    96,     0,     0,     0,   145,   111,   149,     0,
       0,     0,     0,     0,     0,     0,   112,   276,   240,   239,
       0,   211,     0,     0,     0,   245,   251,   250,     0,     0,
     265,   267,   234,   232,   233,    65,     0,     0,   313,    68,
       0,     0,   196,   195,     0,   192,    78,   152,     0,     0,
       0,     0,     0,     0,   326,    73,    38,   288,   289,   227,
     230,   228,   229,   291,   298,   299,     0,   297,   296,     0,
       0,     0,   222,   216,   215,   224,   221,   223,     0,   287,
      46,     0,   328,     0,   103,    97,    95,     0,   100,   146,
       0,     0,   113,     0,     0,     0,     0,     0,     0,     0,
     271,   240,   252,     0,     0,   260,   255,   259,   212,   241,
     244,     0,     0,     0,     0,     0,   261,   264,     0,   317,
     318,   316,     0,     0,   194,   161,   163,   167,   165,   169,
     171,     0,   290,    49,    48,     0,     0,     0,     0,   235,
       0,    19,    94,     0,     0,   117,   118,     0,     0,   114,
     115,   116,   249,     0,   248,   247,   270,   268,   253,   269,
     254,     0,     0,     0,   266,   284,   283,     0,   286,   199,
       0,   294,   295,   293,   292,     0,     0,   217,   219,   218,
     220,    58,     0,     0,     0,     0,     0,   280,     0,     0,
     275,     0,   273,   198,    51,    50,   109,   107,   110,   108,
     246,   282,   281,   285,   272,   274
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -585,   757,  -585,  -585,    45,  -585,   811,   400,   -40,  -585,
    -585,  -585,  -585,  -585,  -585,  -585,  -585,  -585,  -585,   742,
     255,   -80,   147,     3,  -585,  -585,  -585,  -585,  -585,  -585,
    -231,  -585,  -585,  -585,  -585,  -585,  -585,  -585,   552,  -176,
    -585,  -585,   -91,   538,   128,   -83,   -79,   539,  -144,   363,
    -585,   -96,   555,  -585,  -115,   427,  -585,  -585,  -585,  -585,
      28,   181,  -585,   828,  -585,  -585,  -585,  -585,  -408,  -585,
    -585,  -279,  -585,   189,  -585,  -566,  -499,  -256,  -585,  -585,
    -585,  -584,  -585,  -585,  -585,  -585,  -585,  -585,  -585,  -276,
    -274,  -236,  -585,  -241,  -232,    -3,  -585,  -585,  -585,  -585,
     321,   573,   -99,  -154,  -585,  -585,  -585,  -585
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,    15,    37,    87,    17,    29,    67,    63,   172,
      88,   110,   111,   112,   113,    89,   176,    90,    91,    92,
     479,   122,   165,    66,    18,    41,   132,   217,    19,    43,
     154,   155,    20,    45,    21,    32,   126,   195,   283,   284,
     285,   392,   386,   387,   197,   198,   199,   396,   288,   289,
     451,   158,   159,   160,   161,   162,   163,   164,   319,   226,
     314,   221,    22,    34,   127,   203,   204,   205,   370,   371,
     480,   372,   206,   514,   515,   516,   517,   518,   207,   519,
     520,   521,   681,   682,   208,   209,   210,   211,   212,   373,
     374,   422,   556,   423,   424,    48,    23,   128,   216,   434,
     435,   334,   124,   125,    24,    40,    58,    75
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      30,    30,    33,    35,    35,    38,    39,    42,    44,    46,
     166,    64,   513,   593,   335,    50,    47,    49,    53,   270,
     271,   178,   156,   654,    54,   361,   157,   428,   559,   168,
     429,   376,   430,   666,   644,   196,   375,   241,    62,   177,
     377,   652,   560,   186,   187,   360,    16,   362,   421,   297,
     186,   187,   173,   665,    74,    96,    68,    68,    68,    80,
      93,    93,    68,    68,    68,   432,   174,   -45,   266,   568,
     431,   491,   268,   680,   433,   312,   241,    56,   108,   304,
     317,   116,   182,   305,    55,   114,   115,   486,   182,   471,
     182,    59,   449,   119,   489,  -256,   182,   492,   130,   123,
     276,   645,   277,   385,   385,   300,   120,   390,   653,  -258,
     695,    57,   123,   175,   301,   302,    16,   602,  -238,   241,
    -256,  -238,   123,   123,   313,    60,   313,   473,   652,    61,
    -238,   313,   472,   313,  -258,    51,   474,    52,   233,  -257,
    -255,   219,   603,   220,   676,    62,   401,   333,   467,   478,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   156,    76,  -257,  -255,   157,   604,   333,   180,
     123,   194,   201,   214,   123,  -260,   123,   123,    95,   523,
    -259,   101,   102,   123,   522,   123,   181,   358,   524,   233,
     233,   246,   605,   247,   248,   653,   554,   117,   562,    65,
    -260,   563,   393,   564,   359,  -259,   464,   465,   390,   119,
      97,   487,   487,   -65,   233,   249,   233,    25,    26,   250,
     251,   233,   167,   219,    27,   222,    28,   -65,    98,   545,
     -65,   186,   187,   471,   557,    99,   566,   569,   103,   555,
     156,   565,   121,   558,   157,   567,   104,   490,   428,   678,
     315,   609,   153,   610,   590,   320,   594,   321,   500,   501,
     391,   503,   504,   505,   252,   105,   253,   254,   224,   378,
     225,   596,    62,   153,   202,   215,   595,   106,   463,   170,
     597,   307,   625,   308,   233,   233,   432,   233,   255,   171,
     233,   431,   256,   257,   233,   433,   488,   488,    25,    26,
     482,   425,   426,   378,   219,    27,   227,    28,   219,   233,
     229,    13,   118,    14,   233,   223,   281,   228,   230,   286,
     627,   439,   440,    25,    26,   626,   275,   450,   131,   628,
      27,   570,    28,   571,   287,   153,   439,   441,   153,   298,
     299,   300,   661,   532,   594,   646,   647,   648,   649,   650,
     301,   302,   658,   318,   169,   298,   299,   300,   200,   299,
     300,   123,   544,   123,   123,   378,   301,   302,   303,   301,
     302,   179,   153,   444,   445,   182,   481,   156,   439,   446,
     663,   157,   218,   123,   632,   662,   231,   594,   233,   664,
     439,   447,   153,   233,   458,   459,   233,   578,   233,   233,
     233,   233,   233,   233,   233,   623,   624,   258,   259,   260,
     261,   262,   263,    25,    26,   236,   523,   525,   507,   369,
      27,   522,    28,   262,   263,   524,   409,   410,   411,   412,
     413,   237,   153,   238,   612,   239,   398,   436,   240,   437,
     458,   461,   244,   573,   442,   153,   153,   153,   153,   153,
     399,   369,   245,   369,    69,    70,   153,   264,   153,    77,
      78,    79,   265,   153,   298,   299,   300,    13,   267,    14,
     153,   269,   378,   630,   378,   301,   302,   468,   469,    25,
      26,   272,    72,    25,    26,   273,    27,   233,    28,   395,
      27,   233,    28,   274,   298,   299,   300,   233,   233,   278,
     233,   233,   233,   282,   232,   301,   302,   425,   279,   525,
     280,   684,   685,   306,   213,   369,   529,   660,   323,   414,
     415,    73,   357,   109,   378,   324,   497,   301,   302,   416,
     527,   528,    25,    26,   417,   331,   506,    25,    26,    27,
     356,    28,    25,    26,    27,   153,    28,   362,   363,    27,
     418,    28,   419,   580,   581,   153,   585,   586,   378,   379,
     408,   380,   123,   123,   621,   622,   531,   369,   481,   367,
      93,   534,   535,   235,   399,   123,   420,    25,    26,   242,
     310,   298,   299,   300,    27,   153,    28,    25,    26,   381,
     153,   153,   301,   302,    27,   382,    28,   425,   425,   425,
     425,   425,   425,   533,   425,   425,   402,   153,   603,   642,
     309,   603,   690,   383,   494,   495,   389,   403,   378,   577,
     405,   406,   369,   407,   369,     3,     4,   582,     5,     6,
       7,     8,     9,    10,    11,    12,   460,   263,   153,   475,
     425,   298,   299,   300,   462,   466,   153,    13,   467,    14,
     397,   400,   301,   302,   525,   476,   397,   369,   322,   369,
     400,   325,   478,   326,   327,   328,   329,   330,   123,   123,
     477,   298,   299,   300,   369,   400,   483,   485,   484,   655,
     400,   530,   301,   302,   656,   348,   349,   350,   351,   352,
     353,   425,    25,    26,   100,   493,   302,   362,   363,    27,
     418,    28,   419,   260,   261,   262,   263,   526,   369,   634,
     536,   635,   636,   537,   638,   639,   640,   641,   546,   367,
     547,   549,   548,   550,   551,   552,   657,   633,   153,   572,
     153,   153,   637,   153,   153,   153,   153,    25,    26,   574,
     598,   599,   600,   601,    27,   606,    28,   369,   369,   369,
     369,   369,   369,   608,   369,   369,   607,   468,  -257,   496,
     605,    81,   498,    82,   400,   659,   667,   496,   369,   603,
      13,    83,    14,    84,   494,   502,   668,   129,    25,    26,
      85,   669,    25,    26,   670,    27,    81,    28,    82,    27,
     369,    28,   671,   672,   674,    13,    83,    14,    84,   592,
     686,   687,   688,   689,   369,    85,   694,    25,    26,   683,
     691,   692,   693,    71,    27,    31,    28,    86,   388,   153,
     153,   153,   153,   107,    25,    26,   629,    25,    26,   290,
     384,    27,   404,    28,    27,    36,    28,   355,    25,    26,
     394,   369,    94,   291,   292,    27,   679,    28,   611,     0,
     311,     0,     0,   400,     0,     0,     0,   579,     0,     0,
     293,   438,     0,   400,   400,   294,   400,   400,   400,   295,
     296,   183,     0,     0,     0,   399,     0,     0,     0,   538,
     539,   540,   541,   542,   543,   133,   134,   135,   136,   137,
     184,    13,     0,    14,     0,   185,   140,     0,     0,   186,
     187,     0,     0,    25,    26,   298,   299,   300,   142,   143,
      27,   144,    28,   145,     0,     0,   301,   302,   258,   259,
     260,   261,   262,   263,     0,     0,     0,   614,   452,   188,
     146,   147,   148,   149,   150,   151,     0,   189,   190,   191,
     133,   134,   135,   136,   137,   184,   192,   193,     0,     0,
     185,   140,   258,   259,   260,   261,   262,   263,    25,    26,
       0,     0,   453,   142,   143,    27,   144,    28,   145,     0,
       0,    25,    26,     0,     0,     0,   362,   363,   364,   365,
      28,   366,     0,     0,   188,   146,   147,   148,   149,   150,
     151,     0,     0,     0,   191,     0,     0,     0,   367,     0,
     576,   192,   193,   133,   134,   135,   136,   137,   184,   427,
      25,    26,     0,   185,   140,     0,     0,    27,     0,    28,
       0,    25,    26,     0,     0,     0,   142,   143,    27,   144,
      28,   145,     0,   316,     0,     0,    25,    26,     0,     0,
       0,   362,   363,    27,   470,    28,   366,   188,   146,   147,
     148,   149,   150,   151,     0,     0,     0,   191,   133,   134,
     135,   136,   137,   367,   192,   193,    25,    26,     0,   140,
       0,     0,     0,    27,   553,    28,    25,    26,   298,   299,
     300,   142,   143,    27,   144,    28,   145,     0,   613,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   133,   134,
     135,   136,   137,   146,   147,   148,   149,   150,   151,   140,
       0,     0,   152,     0,   332,     0,    25,    26,   298,   299,
     300,   142,   143,    27,   144,    28,   145,     0,   673,   301,
     302,     0,    25,    26,     0,     0,     0,     0,     0,    27,
       0,    28,     0,   146,   147,   148,   149,   150,   151,    81,
       0,    82,   152,     0,   354,   443,     0,     0,    13,    83,
      14,    84,   133,   134,   135,   136,   137,   138,    85,   399,
      25,    26,   139,   140,     0,     0,     0,    27,     0,    28,
      25,    26,     0,     0,   141,   142,   143,    27,   144,    28,
     145,   298,   299,   300,     0,   133,   134,   135,   136,   137,
       0,   675,   301,   302,     0,   631,   140,   146,   147,   148,
     149,   150,   151,    25,    26,     0,   152,     0,   142,   143,
      27,   144,    28,   145,     0,     0,     0,     0,   133,   134,
     135,   136,   137,     0,     0,     0,     0,     0,     0,   140,
     146,   147,   148,   149,   150,   151,    25,    26,     0,   152,
       0,   142,     0,    27,     0,    28,     0,     0,     0,     0,
       0,   133,   134,   135,   136,   137,     0,     0,     0,     0,
       0,     0,   140,   146,   147,   148,   149,   150,   151,    25,
      26,     0,   234,     0,   142,     0,    27,     0,    28,    25,
      26,     0,     0,     0,   362,   363,    27,   591,    28,   509,
       0,     0,     0,     0,     0,     0,   146,   147,   148,   149,
     150,   151,    25,    26,     0,   152,   367,   362,   363,    27,
     418,    28,   419,    25,    26,     0,     0,   592,    25,    26,
      27,     0,    28,    25,    26,    27,     0,    28,     0,   367,
      27,     0,    28,     0,     0,     0,   499,     0,    25,    26,
     592,   575,    25,    26,     0,    27,   583,    28,     0,    27,
     399,    28,     0,     0,     0,   399,     0,    25,    26,     0,
     399,   584,    25,    26,    27,   587,    28,     0,     0,    27,
       0,    28,     0,     0,     0,   399,     0,     0,     0,   399,
     588,    25,    26,     0,     0,   589,   362,   363,   364,   508,
      28,   509,     0,   510,   399,    25,    26,     0,     0,   399,
     362,   363,   364,   508,    28,   509,     0,   510,   367,   258,
     259,   260,   261,   262,   263,     0,   511,   512,     0,     0,
     448,     0,   367,     0,     0,     0,     0,    25,    26,     0,
     677,   512,   362,   363,    27,   418,    28,   419,     0,   510,
      25,    26,     0,     0,     0,   362,   363,   364,   365,    28,
     366,    25,    26,     0,   367,     0,   362,   363,   364,   365,
      28,   366,     0,   651,    25,    26,     0,   367,     0,   362,
     363,    27,   418,    28,   419,     0,   368,     0,   367,     0,
       0,     0,  -158,     0,  -158,  -158,     0,   561,     0,     0,
       0,   367,  -158,  -158,  -158,  -158,  -158,  -158,     0,     0,
     643,   243,  -157,     0,  -157,  -157,  -158,     0,     0,     0,
    -158,  -158,  -157,  -157,  -157,  -157,  -157,  -157,     0,     0,
       0,     0,  -156,     0,  -156,  -156,  -157,     0,     0,     0,
    -157,  -157,  -156,  -156,  -156,  -156,  -156,  -156,   258,   259,
     260,   261,   262,   263,     0,     0,  -156,     0,   454,     2,
    -156,  -156,     3,     4,     0,     5,     6,     7,     8,     9,
      10,    11,    12,    25,    26,     0,     0,     0,   362,   363,
      27,   470,    28,   366,    13,     0,    14,    25,    26,     0,
       0,     0,   362,   363,    27,   418,    28,   419,    25,    26,
     367,     0,     0,   362,   363,   364,   365,    28,   366,     0,
       0,     0,     0,     0,   367,   258,   259,   260,   261,   262,
     263,     0,     0,     0,     0,   367,   615,   258,   259,   260,
     261,   262,   263,     0,     0,     0,     0,     0,   616,   258,
     259,   260,   261,   262,   263,     0,     0,     0,     0,     0,
     617,   258,   259,   260,   261,   262,   263,     0,     0,     0,
       0,     0,   618,   258,   259,   260,   261,   262,   263,     0,
       0,     0,     0,     0,   619,   258,   259,   260,   261,   262,
     263,     0,     0,     0,     0,     0,   620,   258,   259,   260,
     261,   262,   263,     0,     0,     0,     0,   455,   258,   259,
     260,   261,   262,   263,     0,     0,     0,     0,   456,   258,
     259,   260,   261,   262,   263,     0,     0,     0,     0,   457
};

static const yytype_int16 yycheck[] =
{
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
     106,    51,   420,   512,   245,    71,    13,    14,    60,   173,
     174,   120,   105,   607,    60,    17,   105,   306,    17,   109,
     306,   272,   306,    17,   600,   126,   272,   152,    59,   119,
     272,   607,    31,    33,    34,    31,     1,    42,   304,   193,
      33,    34,    17,    31,    57,    76,    53,    54,    55,    62,
      63,    64,    59,    60,    61,   306,    31,    32,   167,    64,
     306,    53,   171,   657,   306,   219,   191,    71,    81,    78,
     224,    84,    74,    82,    60,    82,    83,    77,    74,   368,
      74,    60,   323,    60,    77,    49,    74,    79,   101,    96,
     180,   600,   182,   279,   280,    52,    73,   283,   607,    49,
     694,    73,   109,    78,    61,    62,    71,    49,    72,   234,
      74,    75,   119,   120,   220,    60,   222,   368,   694,    60,
      84,   227,   368,   229,    74,    71,   368,    73,   141,    49,
      49,    71,    74,    73,   643,    59,   290,   243,    58,    58,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   245,    71,    74,    74,   245,    49,   264,    60,
     167,   126,   127,   128,   171,    49,   173,   174,    74,   420,
      49,    74,    75,   180,   420,   182,    77,    60,   420,   192,
     193,    54,    74,    56,    57,   694,   475,    35,   477,    52,
      74,   477,   285,   477,    77,    74,   360,   361,   384,    60,
      71,   387,   388,    59,   217,    78,   219,    37,    38,    82,
      83,   224,    73,    71,    44,    73,    46,    73,    71,   460,
      76,    33,    34,   512,   475,    71,   477,   478,    48,   475,
     323,   477,    95,   475,   323,   477,    71,   391,   527,   657,
     222,   527,   105,   527,   510,   227,   512,   229,   402,   403,
      80,   405,   406,   407,    54,    71,    56,    57,    71,   272,
      73,   512,    59,   126,   127,   128,   512,    71,   358,    66,
     512,    79,   561,    81,   287,   288,   527,   290,    78,    76,
     293,   527,    82,    83,   297,   527,   387,   388,    37,    38,
     380,   304,   305,   306,    71,    44,    73,    46,    71,   312,
      73,    25,    35,    27,   317,   134,   188,   136,   137,   191,
     561,    74,    75,    37,    38,   561,   179,   324,    71,   561,
      44,    72,    46,    74,    73,   188,    74,    75,   191,    50,
      51,    52,   621,   439,   600,   601,   602,   603,   604,   605,
      61,    62,   608,   225,    35,    50,    51,    52,    72,    51,
      52,   358,   458,   360,   361,   368,    61,    62,    79,    61,
      62,    74,   225,    74,    75,    74,   379,   460,    74,    75,
     621,   460,    72,   380,    79,   621,    73,   643,   391,   621,
      74,    75,   245,   396,    74,    75,   399,   493,   401,   402,
     403,   404,   405,   406,   407,   559,   560,    64,    65,    66,
      67,    68,    69,    37,    38,    73,   657,   420,   415,   272,
      44,   657,    46,    68,    69,   657,   298,   299,   300,   301,
     302,    73,   285,    73,   530,    73,    60,   309,    73,   311,
      74,    75,    72,   483,   316,   298,   299,   300,   301,   302,
      74,   304,    40,   306,    54,    55,   309,    73,   311,    59,
      60,    61,    72,   316,    50,    51,    52,    25,    42,    27,
     323,    35,   475,   572,   477,    61,    62,    42,    43,    37,
      38,    71,    36,    37,    38,    32,    44,   490,    46,    75,
      44,   494,    46,    75,    50,    51,    52,   500,   501,    71,
     503,   504,   505,    72,   141,    61,    62,   510,    76,   512,
      76,   665,   666,    73,    72,   368,    72,   613,    71,    14,
      15,    75,    60,    28,   527,    76,   398,    61,    62,    24,
      74,    75,    37,    38,    29,    75,   408,    37,    38,    44,
      75,    46,    37,    38,    44,   398,    46,    42,    43,    44,
      45,    46,    47,    37,    38,   408,    37,    38,   561,    71,
      60,    60,   559,   560,    74,    75,   438,   420,   571,    64,
     573,   443,   444,   146,    74,   572,    71,    37,    38,   152,
     217,    50,    51,    52,    44,   438,    46,    37,    38,    75,
     443,   444,    61,    62,    44,    77,    46,   600,   601,   602,
     603,   604,   605,    72,   607,   608,    42,   460,    74,    75,
      60,    74,    75,    72,    74,    75,    72,    42,   621,   491,
      42,    42,   475,    42,   477,     3,     4,   499,     6,     7,
       8,     9,    10,    11,    12,    13,    39,    69,   491,    73,
     643,    50,    51,    52,    42,    58,   499,    25,    58,    27,
     287,   288,    61,    62,   657,    72,   293,   510,   231,   512,
     297,   234,    58,   236,   237,   238,   239,   240,   665,   666,
      84,    50,    51,    52,   527,   312,    71,    79,    72,    24,
     317,    60,    61,    62,    29,   258,   259,   260,   261,   262,
     263,   694,    37,    38,    72,    78,    62,    42,    43,    44,
      45,    46,    47,    66,    67,    68,    69,    83,   561,   581,
      72,   583,   584,    77,   586,   587,   588,   589,    77,    64,
      44,    75,    45,    75,    75,    75,    71,   580,   581,    73,
     583,   584,   585,   586,   587,   588,   589,    37,    38,    79,
      72,    72,    84,    49,    44,    72,    46,   600,   601,   602,
     603,   604,   605,    78,   607,   608,    84,    42,    74,   396,
      74,    16,   399,    18,   401,    72,    75,   404,   621,    74,
      25,    26,    27,    28,    74,    75,    75,    36,    37,    38,
      35,    75,    37,    38,    75,    44,    16,    46,    18,    44,
     643,    46,    75,    60,    60,    25,    26,    27,    28,    75,
     672,   673,   674,   675,   657,    35,    84,    37,    38,    72,
      72,    72,    72,    56,    44,     4,    46,    72,   280,   672,
     673,   674,   675,    81,    37,    38,   571,    37,    38,    42,
     278,    44,   293,    46,    44,     7,    46,   264,    37,    38,
     285,   694,    72,    56,    57,    44,   657,    46,   527,    -1,
      60,    -1,    -1,   490,    -1,    -1,    -1,   494,    -1,    -1,
      73,    60,    -1,   500,   501,    78,   503,   504,   505,    82,
      83,     5,    -1,    -1,    -1,    74,    -1,    -1,    -1,   452,
     453,   454,   455,   456,   457,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    -1,    29,    30,    -1,    -1,    33,
      34,    -1,    -1,    37,    38,    50,    51,    52,    42,    43,
      44,    45,    46,    47,    -1,    -1,    61,    62,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    72,    74,    63,
      64,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      19,    20,    21,    22,    23,    24,    80,    81,    -1,    -1,
      29,    30,    64,    65,    66,    67,    68,    69,    37,    38,
      -1,    -1,    74,    42,    43,    44,    45,    46,    47,    -1,
      -1,    37,    38,    -1,    -1,    -1,    42,    43,    44,    45,
      46,    47,    -1,    -1,    63,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    64,    -1,
      79,    80,    81,    19,    20,    21,    22,    23,    24,    75,
      37,    38,    -1,    29,    30,    -1,    -1,    44,    -1,    46,
      -1,    37,    38,    -1,    -1,    -1,    42,    43,    44,    45,
      46,    47,    -1,    60,    -1,    -1,    37,    38,    -1,    -1,
      -1,    42,    43,    44,    45,    46,    47,    63,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    19,    20,
      21,    22,    23,    64,    80,    81,    37,    38,    -1,    30,
      -1,    -1,    -1,    44,    75,    46,    37,    38,    50,    51,
      52,    42,    43,    44,    45,    46,    47,    -1,    60,    61,
      62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,
      21,    22,    23,    64,    65,    66,    67,    68,    69,    30,
      -1,    -1,    73,    -1,    75,    -1,    37,    38,    50,    51,
      52,    42,    43,    44,    45,    46,    47,    -1,    60,    61,
      62,    -1,    37,    38,    -1,    -1,    -1,    -1,    -1,    44,
      -1,    46,    -1,    64,    65,    66,    67,    68,    69,    16,
      -1,    18,    73,    -1,    75,    60,    -1,    -1,    25,    26,
      27,    28,    19,    20,    21,    22,    23,    24,    35,    74,
      37,    38,    29,    30,    -1,    -1,    -1,    44,    -1,    46,
      37,    38,    -1,    -1,    41,    42,    43,    44,    45,    46,
      47,    50,    51,    52,    -1,    19,    20,    21,    22,    23,
      -1,    60,    61,    62,    -1,    72,    30,    64,    65,    66,
      67,    68,    69,    37,    38,    -1,    73,    -1,    42,    43,
      44,    45,    46,    47,    -1,    -1,    -1,    -1,    19,    20,
      21,    22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      64,    65,    66,    67,    68,    69,    37,    38,    -1,    73,
      -1,    42,    -1,    44,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    30,    64,    65,    66,    67,    68,    69,    37,
      38,    -1,    73,    -1,    42,    -1,    44,    -1,    46,    37,
      38,    -1,    -1,    -1,    42,    43,    44,    45,    46,    47,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    37,    38,    -1,    73,    64,    42,    43,    44,
      45,    46,    47,    37,    38,    -1,    -1,    75,    37,    38,
      44,    -1,    46,    37,    38,    44,    -1,    46,    -1,    64,
      44,    -1,    46,    -1,    -1,    -1,    60,    -1,    37,    38,
      75,    60,    37,    38,    -1,    44,    60,    46,    -1,    44,
      74,    46,    -1,    -1,    -1,    74,    -1,    37,    38,    -1,
      74,    60,    37,    38,    44,    60,    46,    -1,    -1,    44,
      -1,    46,    -1,    -1,    -1,    74,    -1,    -1,    -1,    74,
      60,    37,    38,    -1,    -1,    60,    42,    43,    44,    45,
      46,    47,    -1,    49,    74,    37,    38,    -1,    -1,    74,
      42,    43,    44,    45,    46,    47,    -1,    49,    64,    64,
      65,    66,    67,    68,    69,    -1,    72,    73,    -1,    -1,
      75,    -1,    64,    -1,    -1,    -1,    -1,    37,    38,    -1,
      72,    73,    42,    43,    44,    45,    46,    47,    -1,    49,
      37,    38,    -1,    -1,    -1,    42,    43,    44,    45,    46,
      47,    37,    38,    -1,    64,    -1,    42,    43,    44,    45,
      46,    47,    -1,    73,    37,    38,    -1,    64,    -1,    42,
      43,    44,    45,    46,    47,    -1,    73,    -1,    64,    -1,
      -1,    -1,    54,    -1,    56,    57,    -1,    73,    -1,    -1,
      -1,    64,    64,    65,    66,    67,    68,    69,    -1,    -1,
      73,    73,    54,    -1,    56,    57,    78,    -1,    -1,    -1,
      82,    83,    64,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    -1,    54,    -1,    56,    57,    78,    -1,    -1,    -1,
      82,    83,    64,    65,    66,    67,    68,    69,    64,    65,
      66,    67,    68,    69,    -1,    -1,    78,    -1,    74,     0,
      82,    83,     3,     4,    -1,     6,     7,     8,     9,    10,
      11,    12,    13,    37,    38,    -1,    -1,    -1,    42,    43,
      44,    45,    46,    47,    25,    -1,    27,    37,    38,    -1,
      -1,    -1,    42,    43,    44,    45,    46,    47,    37,    38,
      64,    -1,    -1,    42,    43,    44,    45,    46,    47,    -1,
      -1,    -1,    -1,    -1,    64,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    -1,    64,    75,    64,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    -1,    -1,    75,    64,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,
      75,    64,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      -1,    -1,    75,    64,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    -1,    -1,    75,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    -1,    -1,    75,    64,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    -1,    74,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    -1,    74,    64,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    -1,    74
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    86,     0,     3,     4,     6,     7,     8,     9,    10,
      11,    12,    13,    25,    27,    87,    89,    90,   109,   113,
     117,   119,   147,   181,   189,    37,    38,    44,    46,    91,
     180,    91,   120,   180,   148,   180,   148,    88,   180,   180,
     190,   110,   180,   114,   180,   118,   180,   108,   180,   108,
      71,    71,    73,    60,    60,    60,    71,    73,   191,    60,
      60,    60,    59,    93,    93,   107,   108,    92,   108,    92,
      92,    86,    36,    75,   180,   192,    71,    92,    92,    92,
     180,    16,    18,    26,    28,    35,    72,    89,    95,   100,
     102,   103,   104,   180,    72,    74,    76,    71,    71,    71,
      72,    74,    75,    48,    71,    71,    71,   104,   180,    28,
      96,    97,    98,    99,   108,   108,   180,    35,    35,    60,
      73,   107,   106,   108,   187,   188,   121,   149,   182,    36,
     180,    71,   111,    19,    20,    21,    22,    23,    24,    29,
      30,    41,    42,    43,    45,    47,    64,    65,    66,    67,
      68,    69,    73,   107,   115,   116,   130,   131,   136,   137,
     138,   139,   140,   141,   142,   107,   136,    73,   106,    35,
      66,    76,    94,    17,    31,    78,   101,   106,   187,    74,
      60,    77,    74,     5,    24,    29,    33,    34,    63,    71,
      72,    73,    80,    81,    89,   122,   127,   129,   130,   131,
      72,    89,   107,   150,   151,   152,   157,   163,   169,   170,
     171,   172,   173,    72,    89,   107,   183,   112,    72,    71,
      73,   146,    73,   146,    71,    73,   144,    73,   146,    73,
     146,    73,   134,   180,    73,   140,    73,    73,    73,    73,
      73,   139,   140,    73,    72,    40,    54,    56,    57,    78,
      82,    83,    54,    56,    57,    78,    82,    83,    64,    65,
      66,    67,    68,    69,    73,    72,   187,    42,   187,    35,
     188,   188,    71,    32,    75,   107,   106,   106,    71,    76,
      76,   129,    72,   123,   124,   125,   129,    73,   133,   134,
      42,    56,    57,    73,    78,    82,    83,   133,    50,    51,
      52,    61,    62,    79,    78,    82,    73,    79,    81,    60,
     134,    60,   133,   136,   145,   145,    60,   133,   129,   143,
     145,   145,   140,    71,    76,   140,   140,   140,   140,   140,
     140,    75,    75,   136,   186,   115,   136,   136,   136,   136,
     136,   136,   136,   136,   136,   136,   136,   136,   140,   140,
     140,   140,   140,   140,    75,   186,    75,    60,    60,    77,
      31,    17,    42,    43,    44,    45,    47,    64,    73,   107,
     153,   154,   156,   174,   175,   176,   178,   179,   180,    71,
      60,    75,    77,    72,   123,   124,   127,   128,   128,    72,
     124,    80,   126,   130,   137,    75,   132,   134,    60,    74,
     134,   133,    42,    42,   132,    42,    42,    42,    60,   129,
     129,   129,   129,   129,    14,    15,    24,    29,    45,    47,
      71,   162,   176,   178,   179,   180,   180,    75,   156,   174,
     175,   176,   178,   179,   184,   185,   129,   129,    60,    74,
      75,    75,   129,    60,    74,    75,    75,    75,    75,   115,
     108,   135,    74,    74,    74,    74,    74,    74,    74,    75,
      39,    75,    42,   106,   188,   188,    58,    58,    42,    43,
      45,   156,   176,   178,   179,    73,    72,    84,    58,   105,
     155,   180,   106,    71,    72,    79,    77,   124,   127,    77,
     133,    53,    79,    78,    74,    75,   134,   129,   134,    60,
     133,   133,    75,   133,   133,   133,   129,   108,    45,    47,
      49,    72,    73,   153,   158,   159,   160,   161,   162,   164,
     165,   166,   176,   178,   179,   180,    83,    74,    75,    72,
      60,   129,   136,    72,   129,   129,    72,    77,   140,   140,
     140,   140,   140,   140,   136,   115,    77,    44,    45,    75,
      75,    75,    75,    75,   156,   176,   177,   178,   179,    17,
      31,    73,   156,   174,   175,   176,   178,   179,    64,   178,
      72,    74,    73,    93,    79,    60,    79,   129,   136,   134,
      37,    38,   129,    60,    60,    37,    38,    60,    60,    60,
     162,    45,    75,   161,   162,   176,   178,   179,    72,    72,
      84,    49,    49,    74,    49,    74,    72,    84,    78,   174,
     175,   185,   136,    60,    72,    75,    75,    75,    75,    75,
      75,    74,    75,   188,   188,   156,   176,   178,   179,   105,
     187,    72,    79,   107,   129,   129,   129,   107,   129,   129,
     129,   129,    75,    73,   160,   161,   162,   162,   162,   162,
     162,    73,   160,   161,   166,    24,    29,    71,   162,    72,
     136,   156,   176,   178,   179,    31,    17,    75,    75,    75,
      75,    75,    60,    60,    60,    60,   161,    72,   153,   158,
     166,   167,   168,    72,   188,   188,   129,   129,   129,   129,
      75,    72,    72,    72,    84,   166
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,    85,    86,    86,    86,    86,    86,    86,    86,    86,
      86,    86,    86,    87,    88,    89,    89,    90,    90,    90,
      91,    92,    93,    93,    93,    93,    94,    93,    93,    95,
      95,    95,    96,    96,    96,    97,    98,    98,    99,    99,
     100,   100,   100,   100,   100,   101,   100,   100,   100,   100,
     100,   100,   102,   102,   103,   103,   104,   104,   105,   105,
     106,   107,   107,   107,   108,   108,   109,   110,   111,   112,
     112,   113,   114,   115,   115,   115,   116,   116,   116,   117,
     118,   119,   120,   121,   121,   121,   121,   121,   122,   122,
     122,   122,   123,   123,   124,   124,   124,   125,   125,   126,
     126,   127,   127,   128,   128,   128,   128,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
     130,   130,   130,   131,   131,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   132,   132,   132,   133,   133,
     133,   134,   134,   135,   136,   136,   137,   137,   137,   138,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   140,   140,   141,
     141,   141,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   142,   143,   143,   144,   144,   145,   145,   146,   146,
     147,   148,   149,   149,   149,   150,   150,   150,   150,   150,
     150,   151,   152,   153,   153,   154,   154,   154,   154,   154,
     154,   154,   154,   154,   154,   154,   154,   154,   154,   154,
     154,   154,   154,   154,   154,   155,   155,   155,   156,   156,
     156,   157,   157,   157,   158,   158,   159,   159,   159,   159,
     159,   159,   160,   161,   161,   162,   162,   162,   162,   162,
     162,   163,   163,   163,   164,   164,   165,   165,   166,   166,
     166,   166,   167,   167,   168,   168,   169,   170,   170,   170,
     171,   172,   172,   172,   172,   173,   173,   174,   175,   175,
     176,   176,   177,   177,   177,   177,   177,   177,   177,   177,
     178,   178,   179,   179,   180,   180,   180,   180,   181,   182,
     182,   182,   182,   183,   183,   183,   184,   184,   184,   184,
     184,   184,   185,   185,   185,   185,   186,   186,   187,   187,
     188,   188,   189,   190,   191,   191,   192,   192,   192,   192
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     5,     1,     2,     2,     5,     5,    12,
       1,     1,     0,     2,     3,     4,     0,     5,     3,     1,
       1,     1,     1,     1,     1,     2,     4,     3,     6,     5,
       2,     4,     4,     6,     6,     0,     7,     6,     8,     8,
      10,    10,     4,     1,     2,     1,     6,     3,     4,     1,
       1,     4,     6,     1,     3,     1,     7,     1,     5,     0,
       2,     7,     1,     5,     1,     1,     1,     1,     5,     7,
       1,     7,     1,     0,     2,     3,     2,     2,     3,     4,
       2,     3,     2,     1,     5,     4,     3,     4,     0,     1,
       3,     4,     4,     3,     2,     2,     1,     8,     8,     8,
       8,     4,     4,     5,     6,     6,     6,     6,     6,     2,
       3,     3,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     3,     4,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     1,     2,     3,
       1,     1,     4,     1,     1,     1,     4,     3,     1,     1,
       3,     6,     3,     6,     3,     6,     3,     6,     3,     6,
       3,     6,     2,     4,     3,     1,     1,     1,     1,     1,
       1,     1,     4,     2,     4,     2,     4,     2,     4,     2,
       4,     2,     3,     1,     5,     4,     3,     1,     7,     6,
       7,     1,     0,     2,     2,     1,     1,     1,     1,     1,
       1,     4,     5,     2,     1,     3,     3,     5,     5,     5,
       5,     3,     3,     3,     3,     1,     1,     3,     3,     3,
       3,     1,     1,     1,     1,     3,     1,     0,     1,     1,
       1,     5,     3,     3,     2,     1,     5,     3,     3,     3,
       1,     1,     2,     3,     3,     1,     1,     1,     1,     1,
       1,     5,     3,     3,     2,     1,     3,     1,     3,     3,
       3,     2,     2,     1,     3,     1,     4,     1,     1,     1,
       7,     8,     8,     6,     6,     8,     6,     3,     3,     3,
       4,     3,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     2,     1,     2,     1,     1,     1,     1,     7,     0,
       3,     3,     2,     4,     3,     1,     3,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     0,     1,
       3,     1,     5,     1,     2,     3,     3,     3,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 13: /* namespace: NAMESPACE_HEADER namespace_name '{' idp '}'  */
#line 260 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { data().closeNamespace();	}
#line 2374 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 14: /* namespace_name: identifier  */
#line 263 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { data().openNamespace(*(yyvsp[0].str),(yylsp[0])); }
#line 2380 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 15: /* using: USINGNAMESPACE pointer_name  */
#line 266 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { data().usingspace(*(yyvsp[0].vstr),(yylsp[-1])); delete((yyvsp[0].vstr));	}
#line 2386 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 16: /* using: USINGVOCABULARY pointer_name  */
#line 267 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { data().usingvocab(*(yyvsp[0].vstr),(yylsp[-1])); delete((yyvsp[0].vstr));	}
#line 2392 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 17: /* vocabulary: VOCAB_HEADER vocab_name '{' vocab_content '}'  */
#line 277 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { data().closevocab();	}
#line 2398 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 18: /* vocabulary: LTC_VOCAB_HEADER vocab_name '{' vocab_content '}'  */
#line 279 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { data().closeLTCvocab();	}
#line 2404 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 19: /* vocabulary: LTC_VOCAB_HEADER vocab_name '(' intern_pointer ',' intern_pointer ',' intern_pointer ')' '{' vocab_content '}'  */
#line 283 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { data().closeLTCvocab((yyvsp[-8].nsp),(yyvsp[-6].nsp),(yyvsp[-4].nsp));	}
#line 2410 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 20: /* vocab_name: identifier  */
#line 286 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { data().openvocab(*(yyvsp[0].str),(yylsp[0])); }
#line 2416 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 21: /* vocab_pointer: pointer_name  */
#line 289 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                        { data().setvocab(*(yyvsp[0].vstr),(yylsp[0])); delete((yyvsp[0].vstr)); }
#line 2422 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 26: /* $@1: %empty  */
#line 296 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { data().externvocab(*(yyvsp[0].vstr),(yylsp[0])); delete((yyvsp[0].vstr));	}
#line 2428 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 35: /* extern_sort: TYPE sort_pointer  */
#line 310 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { data().sort((yyvsp[0].sor));			}
#line 2434 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 36: /* extern_predicate: pointer_name '[' sort_pointer_tuple ']'  */
#line 313 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { data().predicate(data().predpointer(*(yyvsp[-3].vstr),*(yyvsp[-1].vsor),(yylsp[-3])));
																  delete((yyvsp[-3].vstr)); delete((yyvsp[-1].vsor)); }
#line 2441 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 37: /* extern_predicate: pointer_name '/' INTEGER  */
#line 315 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                        { data().predicate(data().predpointer(*(yyvsp[-2].vstr),(yyvsp[0].nmr),(yylsp[-2])));
																  delete((yyvsp[-2].vstr)); }
#line 2448 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 38: /* extern_function: pointer_name '[' sort_pointer_tuple ':' sort_pointer ']'  */
#line 320 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                                                        { data().function(data().funcpointer(*(yyvsp[-5].vstr),*(yyvsp[-3].vsor),(yylsp[-5])));
																	  delete((yyvsp[-5].vstr)); delete((yyvsp[-3].vsor)); }
#line 2455 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 39: /* extern_function: pointer_name '/' INTEGER ':' INTEGER  */
#line 322 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { data().function(data().funcpointer(*(yyvsp[-4].vstr),(yyvsp[-2].nmr),(yylsp[-4])));
																	  delete((yyvsp[-4].vstr)); }
#line 2462 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 40: /* sort_decl: TYPE identifier  */
#line 327 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.sor) = data().sort(*(yyvsp[0].str),(yylsp[0]));		}
#line 2468 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 41: /* sort_decl: TYPE identifier ISA nonempty_spt  */
#line 329 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                                                                                { (yyval.sor) = data().sort(*(yyvsp[-2].str),*(yyvsp[0].vsor),true,(yylsp[-2])); delete((yyvsp[0].vsor)); }
#line 2474 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 42: /* sort_decl: TYPE identifier EXTENDS nonempty_spt  */
#line 331 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                                                                                { (yyval.sor) = data().sort(*(yyvsp[-2].str),*(yyvsp[0].vsor),false,(yylsp[-2])); delete((yyvsp[0].vsor)); }
#line 2480 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 43: /* sort_decl: TYPE identifier ISA nonempty_spt EXTENDS nonempty_spt  */
#line 333 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                                                                                { (yyval.sor) = data().sort(*(yyvsp[-4].str),*(yyvsp[-2].vsor),*(yyvsp[0].vsor),(yylsp[-4])); delete((yyvsp[-2].vsor)); delete((yyvsp[0].vsor)); }
#line 2486 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 44: /* sort_decl: TYPE identifier EXTENDS nonempty_spt ISA nonempty_spt  */
#line 335 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                                                                                { (yyval.sor) = data().sort(*(yyvsp[-4].str),*(yyvsp[0].vsor),*(yyvsp[-2].vsor),(yylsp[-4])); delete((yyvsp[-2].vsor)); delete((yyvsp[0].vsor)); }
#line 2492 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 45: /* $@2: %empty  */
#line 336 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                  { data().sort(*(yyvsp[0].str),(yylsp[0])); }
#line 2498 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 46: /* sort_decl: TYPE identifier $@2 CONSTRUCTED '{' func_list '}'  */
#line 337 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                                                                                { data().addConstructors((yyvsp[-1].vfunc)); delete((yyvsp[-1].vfunc));}
#line 2504 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 47: /* sort_decl: TYPE identifier '=' '{' elements_es '}'  */
#line 339 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                                                                                { (yyval.sor) = data().sort(*(yyvsp[-4].str),(yylsp[-4]),(yyvsp[-1].sta)); }
#line 2510 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 48: /* sort_decl: TYPE identifier '=' '{' elements_es '}' ISA nonempty_spt  */
#line 341 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                                                                                { (yyval.sor) = data().sort(*(yyvsp[-6].str),*(yyvsp[0].vsor),true,(yylsp[-6]),(yyvsp[-3].sta)); delete((yyvsp[0].vsor)); }
#line 2516 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 49: /* sort_decl: TYPE identifier '=' '{' elements_es '}' EXTENDS nonempty_spt  */
#line 343 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                                                                                { (yyval.sor) = data().sort(*(yyvsp[-6].str),*(yyvsp[0].vsor),false,(yylsp[-6]),(yyvsp[-3].sta)); delete((yyvsp[0].vsor)); }
#line 2522 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 50: /* sort_decl: TYPE identifier '=' '{' elements_es '}' ISA nonempty_spt EXTENDS nonempty_spt  */
#line 345 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                                                                                { (yyval.sor) = data().sort(*(yyvsp[-8].str),*(yyvsp[-2].vsor),*(yyvsp[0].vsor),(yylsp[-8]),(yyvsp[-5].sta)); delete((yyvsp[-2].vsor)); delete((yyvsp[0].vsor)); }
#line 2528 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 51: /* sort_decl: TYPE identifier '=' '{' elements_es '}' EXTENDS nonempty_spt ISA nonempty_spt  */
#line 347 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                                                                                { (yyval.sor) = data().sort(*(yyvsp[-8].str),*(yyvsp[0].vsor),*(yyvsp[-2].vsor),(yylsp[-8]),(yyvsp[-5].sta)); delete((yyvsp[0].vsor)); delete((yyvsp[-2].vsor)); }
#line 2534 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 52: /* pred_decl: identifier '(' sort_pointer_tuple ')'  */
#line 350 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { data().predicate(*(yyvsp[-3].str),*(yyvsp[-1].vsor),(yylsp[-3])); delete((yyvsp[-1].vsor)); }
#line 2540 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 53: /* pred_decl: identifier  */
#line 351 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { data().predicate(*(yyvsp[0].str),(yylsp[0]));  }
#line 2546 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 54: /* func_decl: PARTIAL full_func_decl  */
#line 354 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.fun) = (yyvsp[0].fun); data().partial((yyval.fun));	}
#line 2552 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 55: /* func_decl: full_func_decl  */
#line 355 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { (yyval.fun) = (yyvsp[0].fun);								}
#line 2558 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 56: /* full_func_decl: identifier '(' sort_pointer_tuple ')' ':' sort_pointer  */
#line 358 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.fun) = data().function(*(yyvsp[-5].str),*(yyvsp[-3].vsor),(yyvsp[0].sor),(yylsp[-5]));
																			  delete((yyvsp[-3].vsor)); }
#line 2565 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 57: /* full_func_decl: identifier ':' sort_pointer  */
#line 360 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                                        { (yyval.fun) = data().function(*(yyvsp[-2].str),{},(yyvsp[0].sor),(yylsp[-2])); }
#line 2571 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 58: /* constr_func_decl: identifier '(' sort_pointer_tuple ')'  */
#line 363 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.fun) = data().constructorfunction(*(yyvsp[-3].str),*(yyvsp[-1].vsor), (yylsp[-3])); delete((yyvsp[-1].vsor)); }
#line 2577 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 59: /* constr_func_decl: identifier  */
#line 364 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                        { (yyval.fun) = data().constructorfunction(*(yyvsp[0].str),{},(yylsp[0])); }
#line 2583 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 60: /* sort_pointer: pointer_name  */
#line 370 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.sor) = data().sortpointer(*(yyvsp[0].vstr),(yylsp[0])); delete((yyvsp[0].vstr)); }
#line 2589 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 61: /* intern_pointer: pointer_name '[' sort_pointer_tuple ']'  */
#line 373 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.nsp) = data().internpredpointer(*(yyvsp[-3].vstr),*(yyvsp[-1].vsor),(yylsp[-3]));
																  delete((yyvsp[-3].vstr)); delete((yyvsp[-1].vsor)); }
#line 2596 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 62: /* intern_pointer: pointer_name '[' sort_pointer_tuple ':' sort_pointer ']'  */
#line 376 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                                                { (yyval.nsp) = data().internfuncpointer(*(yyvsp[-5].vstr),*(yyvsp[-3].vsor),(yyvsp[-1].sor),(yylsp[-5]));
																  delete((yyvsp[-5].vstr)); delete((yyvsp[-3].vsor)); }
#line 2603 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 63: /* intern_pointer: pointer_name  */
#line 378 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.nsp) = data().internpointer(*(yyvsp[0].vstr),(yylsp[0]));
																  delete((yyvsp[0].vstr)); }
#line 2610 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 64: /* pointer_name: pointer_name "::" identifier  */
#line 382 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.vstr) = (yyvsp[-2].vstr); (yyval.vstr)->push_back(*(yyvsp[0].str)); 		}
#line 2616 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 65: /* pointer_name: identifier  */
#line 383 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.vstr) = new std::vector<std::string>(1,*(yyvsp[0].str));	}
#line 2622 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 66: /* namedquery: QUERY_HEADER query_name ':' vocab_pointer '{' query '}'  */
#line 390 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { data().closequery((yyvsp[-1].que));	}
#line 2628 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 67: /* query_name: identifier  */
#line 393 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                { data().openquery(*(yyvsp[0].str),(yylsp[0]));	}
#line 2634 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 68: /* query: '{' query_vars ':' formula '}'  */
#line 396 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.que) = data().query(*(yyvsp[-3].vvar),(yyvsp[-1].fom),(yylsp[-4])); delete((yyvsp[-3].vvar));	}
#line 2640 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 69: /* query_vars: %empty  */
#line 399 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.vvar) = new std::vector<Variable*>(0);	}
#line 2646 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 70: /* query_vars: query_vars variable  */
#line 400 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.vvar) = (yyvsp[-1].vvar); (yyval.vvar)->push_back((yyvsp[0].var));		}
#line 2652 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 71: /* namedfobdd: FOBDD_HEADER fobdd_name ':' vocab_pointer '{' fobdd '}'  */
#line 406 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                          {data().closefobdd((yyvsp[-1].bdd));	}
#line 2658 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 72: /* fobdd_name: identifier  */
#line 408 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                {data().openfobdd(*(yyvsp[0].str),(yylsp[0]));	}
#line 2664 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 73: /* fobdd: kernel FALSEBRANCH fobdd TRUEBRANCH fobdd  */
#line 410 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                            { (yyval.bdd) = data().fobdd((yyvsp[-4].kernel),(yyvsp[0].bdd),(yyvsp[-2].bdd));}
#line 2670 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 74: /* fobdd: TRUE  */
#line 411 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                               { (yyval.bdd) = data().truefobdd();}
#line 2676 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 75: /* fobdd: FALSE  */
#line 412 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                { (yyval.bdd) = data().falsefobdd();}
#line 2682 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 76: /* kernel: predicate  */
#line 414 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                            { (yyval.kernel) = data().atomkernel((yyvsp[0].fom));}
#line 2688 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 77: /* kernel: eq_chain  */
#line 415 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                   { (yyval.kernel) = data().atomkernel((yyvsp[0].fom));}
#line 2694 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 78: /* kernel: EXISTS variable '{' fobdd '}'  */
#line 416 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        {(yyval.kernel)=data().quantkernel((yyvsp[-3].var),(yyvsp[-1].bdd));}
#line 2700 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 79: /* namedterm: TERM_HEADER term_name ':' vocab_pointer '{' term '}'  */
#line 426 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { data().closeterm((yyvsp[-1].ter));	}
#line 2706 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 80: /* term_name: identifier  */
#line 429 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                { data().openterm(*(yyvsp[0].str),(yylsp[0]));	}
#line 2712 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 81: /* theory: THEORY_HEADER theory_name ':' vocab_pointer '{' def_forms '}'  */
#line 436 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { data().closetheory();	}
#line 2718 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 82: /* theory_name: identifier  */
#line 439 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                { data().opentheory(*(yyvsp[0].str),(yylsp[0]));  }
#line 2724 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 84: /* def_forms: def_forms definition  */
#line 443 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { data().definition((yyvsp[0].def));	}
#line 2730 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 85: /* def_forms: def_forms formula '.'  */
#line 444 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { data().sentence((yyvsp[-1].fom));		}
#line 2736 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 86: /* def_forms: def_forms fixpdef  */
#line 445 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { data().fixpdef((yyvsp[0].fpd));		}
#line 2742 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 88: /* definition: '{' rules '}'  */
#line 451 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.def) = data().definition(*(yyvsp[-1].vrul)); delete((yyvsp[-1].vrul));	}
#line 2748 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 89: /* definition: DEF_HEADER '{' rules '}'  */
#line 452 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.def) = data().definition(*(yyvsp[-1].vrul)); delete((yyvsp[-1].vrul));	}
#line 2754 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 90: /* definition: '{' '}'  */
#line 454 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.def) = NULL;}
#line 2760 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 91: /* definition: DEF_HEADER '{' '}'  */
#line 455 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.def) = NULL;}
#line 2766 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 92: /* rules: rules rule  */
#line 458 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                { (yyval.vrul) = (yyvsp[-1].vrul); (yyvsp[-1].vrul)->push_back((yyvsp[0].rul));	}
#line 2772 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 93: /* rules: rule  */
#line 459 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.vrul) = new std::vector<Rule*>(1,(yyvsp[0].rul));	}
#line 2778 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 94: /* rule: univquantvars head "<-" formula '.'  */
#line 462 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.rul) = data().rule(*(yyvsp[-4].svar),(yyvsp[-3].fom),(yyvsp[-1].fom),(yylsp[-3])); delete((yyvsp[-4].svar));	}
#line 2784 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 95: /* rule: univquantvars head "<-" '.'  */
#line 463 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.rul) = data().rule(*(yyvsp[-3].svar),(yyvsp[-2].fom),(yylsp[-2])); delete((yyvsp[-3].svar));		}
#line 2790 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 96: /* rule: univquantvars head '.'  */
#line 464 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.rul) = data().rule(*(yyvsp[-2].svar),(yyvsp[-1].fom),(yylsp[-1])); delete((yyvsp[-2].svar));		}
#line 2796 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 97: /* univquantvars: univquantvars '!' variables ':'  */
#line 468 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.svar) = (yyvsp[-3].svar); (yyvsp[-3].svar)->insert((yyvsp[-1].svar)->cbegin(), (yyvsp[-1].svar)->cend()); delete((yyvsp[-1].svar));}
#line 2802 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 98: /* univquantvars: %empty  */
#line 469 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.svar) = new varset(); }
#line 2808 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 99: /* head: predicate  */
#line 472 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.fom) = (yyvsp[0].fom);										}
#line 2814 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 100: /* head: function '=' term  */
#line 473 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.fom) = data().equalityhead((yyvsp[-2].ter),(yyvsp[0].ter),(yylsp[-2]));	}
#line 2820 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 101: /* fixpdef: LFD '[' fd_rules ']'  */
#line 479 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.fpd) = (yyvsp[-1].fpd); data().makeLFD((yyvsp[-1].fpd),true); 	}
#line 2826 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 102: /* fixpdef: GFD '[' fd_rules ']'  */
#line 480 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.fpd) = (yyvsp[-1].fpd); data().makeLFD((yyvsp[-1].fpd),false);	}
#line 2832 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 103: /* fd_rules: fd_rules rule '.'  */
#line 483 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.fpd) = (yyvsp[-2].fpd); data().addRule((yyval.fpd),(yyvsp[-1].rul));					}
#line 2838 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 104: /* fd_rules: fd_rules fixpdef  */
#line 484 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.fpd) = (yyvsp[-1].fpd); data().addDef((yyval.fpd),(yyvsp[0].fpd));					}
#line 2844 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 105: /* fd_rules: rule '.'  */
#line 485 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.fpd) = data().createFD(); data().addRule((yyval.fpd),(yyvsp[-1].rul));	}
#line 2850 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 106: /* fd_rules: fixpdef  */
#line 486 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.fpd) = data().createFD(); data().addDef((yyval.fpd),(yyvsp[0].fpd));		}
#line 2856 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 107: /* formula: '!' '(' variablelist ')' SAT formula ':' formula  */
#line 490 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.fom) = data().implform((yyvsp[-2].fom) ,(yyvsp[0].fom),(yylsp[-7]));
														  (yyval.fom) = data().univform(data().varVectorToSet((yyvsp[-5].vvar)),(yyval.fom),(yylsp[-7])); delete((yyvsp[-5].vvar));}
#line 2863 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 108: /* formula: '?' '(' variablelist ')' SAT formula ':' formula  */
#line 492 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.fom) = data().conjform((yyvsp[-2].fom),(yyvsp[0].fom),(yylsp[-7]));
														  (yyval.fom) = data().existform(data().varVectorToSet((yyvsp[-5].vvar)),(yyval.fom),(yylsp[-7])); delete((yyvsp[-5].vvar));}
#line 2870 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 109: /* formula: '!' '(' variablelist ')' IN intern_pointer ':' formula  */
#line 495 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                                {	 
		  													(yyval.fom) = data().predformVar((yyvsp[-2].nsp),*(yyvsp[-5].vvar),(yylsp[-7]));
		  													(yyval.fom) = data().implform((yyval.fom),(yyvsp[0].fom),(yylsp[-7]));
		  													(yyval.fom) = data().univform(data().varVectorToSet((yyvsp[-5].vvar)),(yyval.fom),(yylsp[-7]));
		  												}
#line 2880 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 110: /* formula: '?' '(' variablelist ')' IN intern_pointer ':' formula  */
#line 501 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                                                        {	 
		  			  													(yyval.fom) = data().predformVar((yyvsp[-2].nsp),*(yyvsp[-5].vvar),(yylsp[-7]));
		  			  													(yyval.fom) = data().conjform((yyval.fom),(yyvsp[0].fom),(yylsp[-7]));
		  			  													(yyval.fom) = data().existform(data().varVectorToSet((yyvsp[-5].vvar)),(yyval.fom),(yylsp[-7]));
		  			  												}
#line 2890 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 111: /* formula: '!' variables ':' formula  */
#line 506 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.fom) = data().univform(*(yyvsp[-2].svar),(yyvsp[0].fom),(yylsp[-3])); delete((yyvsp[-2].svar));		}
#line 2896 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 112: /* formula: '?' variables ':' formula  */
#line 507 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.fom) = data().existform(*(yyvsp[-2].svar),(yyvsp[0].fom),(yylsp[-3])); delete((yyvsp[-2].svar));	}
#line 2902 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 113: /* formula: '?' INTEGER variables ':' formula  */
#line 508 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.fom) = data().bexform(CompType::EQ,(yyvsp[-3].nmr),*(yyvsp[-2].svar),(yyvsp[0].fom),(yylsp[-4]));
														  delete((yyvsp[-2].svar));										}
#line 2909 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 114: /* formula: '?' '=' INTEGER variables ':' formula  */
#line 510 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.fom) = data().bexform(CompType::EQ,(yyvsp[-3].nmr),*(yyvsp[-2].svar),(yyvsp[0].fom),(yylsp[-5]));
														  delete((yyvsp[-2].svar));										}
#line 2916 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 115: /* formula: '?' '<' INTEGER variables ':' formula  */
#line 512 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.fom) = data().bexform(CompType::LT,(yyvsp[-3].nmr),*(yyvsp[-2].svar),(yyvsp[0].fom),(yylsp[-5]));
														  delete((yyvsp[-2].svar));										}
#line 2923 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 116: /* formula: '?' '>' INTEGER variables ':' formula  */
#line 514 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.fom) = data().bexform(CompType::GT,(yyvsp[-3].nmr),*(yyvsp[-2].svar),(yyvsp[0].fom),(yylsp[-5]));
														  delete((yyvsp[-2].svar));										}
#line 2930 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 117: /* formula: '?' "=<" INTEGER variables ':' formula  */
#line 516 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.fom) = data().bexform(CompType::LEQ,(yyvsp[-3].nmr),*(yyvsp[-2].svar),(yyvsp[0].fom),(yylsp[-5]));
														  delete((yyvsp[-2].svar));										}
#line 2937 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 118: /* formula: '?' ">=" INTEGER variables ':' formula  */
#line 518 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.fom) = data().bexform(CompType::GEQ,(yyvsp[-3].nmr),*(yyvsp[-2].svar),(yyvsp[0].fom),(yylsp[-5]));
														  delete((yyvsp[-2].svar));										}
#line 2944 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 119: /* formula: '~' formula  */
#line 520 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { (yyval.fom) = (yyvsp[0].fom); data().negate((yyval.fom));						}
#line 2950 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 120: /* formula: formula '&' formula  */
#line 521 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.fom) = data().conjform((yyvsp[-2].fom),(yyvsp[0].fom),(yylsp[-2]));					}
#line 2956 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 121: /* formula: formula '|' formula  */
#line 522 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.fom) = data().disjform((yyvsp[-2].fom),(yyvsp[0].fom),(yylsp[-2]));					}
#line 2962 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 122: /* formula: formula "=>" formula  */
#line 523 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.fom) = data().implform((yyvsp[-2].fom),(yyvsp[0].fom),(yylsp[-2]));					}
#line 2968 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 123: /* formula: formula "<=" formula  */
#line 524 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.fom) = data().revimplform((yyvsp[-2].fom),(yyvsp[0].fom),(yylsp[-2]));				}
#line 2974 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 124: /* formula: formula "<=>" formula  */
#line 525 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.fom) = data().equivform((yyvsp[-2].fom),(yyvsp[0].fom),(yylsp[-2]));					}
#line 2980 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 125: /* formula: '(' formula ')'  */
#line 526 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.fom) = (yyvsp[-1].fom);											}
#line 2986 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 126: /* formula: TRUE  */
#line 527 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                        { (yyval.fom) = data().trueform((yylsp[0]));						}
#line 2992 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 127: /* formula: FALSE  */
#line 528 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                        { (yyval.fom) = data().falseform((yylsp[0]));						}
#line 2998 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 128: /* formula: eq_chain  */
#line 529 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                        { (yyval.fom) = (yyvsp[0].fom);											}
#line 3004 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 129: /* formula: predicate  */
#line 530 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.fom) = (yyvsp[0].fom);											}
#line 3010 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 130: /* predicate: intern_pointer  */
#line 533 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.fom) = data().predform((yyvsp[0].nsp),(yylsp[0]));					}
#line 3016 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 131: /* predicate: intern_pointer '(' ')'  */
#line 534 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.fom) = data().predform((yyvsp[-2].nsp),(yylsp[-2]));					}
#line 3022 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 132: /* predicate: intern_pointer '(' term_tuple ')'  */
#line 535 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.fom) = data().predform((yyvsp[-3].nsp),*(yyvsp[-1].vter),(yylsp[-3])); delete((yyvsp[-1].vter)); }
#line 3028 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 133: /* eq_chain: eq_chain '=' term  */
#line 538 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                        { (yyval.fom) = data().eqchain(CompType::EQ,(yyvsp[-2].fom),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3034 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 134: /* eq_chain: eq_chain "~=" term  */
#line 539 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.fom) = data().eqchain(CompType::NEQ,(yyvsp[-2].fom),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3040 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 135: /* eq_chain: eq_chain '<' term  */
#line 540 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.fom) = data().eqchain(CompType::LT,(yyvsp[-2].fom),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3046 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 136: /* eq_chain: eq_chain '>' term  */
#line 541 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.fom) = data().eqchain(CompType::GT,(yyvsp[-2].fom),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3052 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 137: /* eq_chain: eq_chain "=<" term  */
#line 542 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.fom) = data().eqchain(CompType::LEQ,(yyvsp[-2].fom),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3058 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 138: /* eq_chain: eq_chain ">=" term  */
#line 543 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.fom) = data().eqchain(CompType::GEQ,(yyvsp[-2].fom),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3064 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 139: /* eq_chain: term '=' term  */
#line 544 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.fom) = data().eqchain(CompType::EQ,(yyvsp[-2].ter),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3070 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 140: /* eq_chain: term "~=" term  */
#line 545 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                        { (yyval.fom) = data().eqchain(CompType::NEQ,(yyvsp[-2].ter),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3076 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 141: /* eq_chain: term '<' term  */
#line 546 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                        { (yyval.fom) = data().eqchain(CompType::LT,(yyvsp[-2].ter),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3082 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 142: /* eq_chain: term '>' term  */
#line 547 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                        { (yyval.fom) = data().eqchain(CompType::GT,(yyvsp[-2].ter),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3088 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 143: /* eq_chain: term "=<" term  */
#line 548 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                        { (yyval.fom) = data().eqchain(CompType::LEQ,(yyvsp[-2].ter),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3094 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 144: /* eq_chain: term ">=" term  */
#line 549 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                        { (yyval.fom) = data().eqchain(CompType::GEQ,(yyvsp[-2].ter),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3100 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 145: /* variablelist: variablelist variable  */
#line 551 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                    {(yyval.vvar) = (yyvsp[-1].vvar); (yyval.vvar)->push_back((yyvsp[0].var));}
#line 3106 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 146: /* variablelist: variablelist ',' variable  */
#line 552 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                    {(yyval.vvar) = (yyvsp[-2].vvar); (yyval.vvar)->push_back((yyvsp[0].var));}
#line 3112 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 147: /* variablelist: variable  */
#line 553 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                   {(yyval.vvar) = new std::vector<Variable*>(); (yyval.vvar)->push_back((yyvsp[0].var));}
#line 3118 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 148: /* variables: variables variable  */
#line 555 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                        { (yyval.svar) = (yyvsp[-1].svar); (yyval.svar)->insert((yyvsp[0].var));						}
#line 3124 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 149: /* variables: variables ',' variable  */
#line 556 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.svar) = (yyvsp[-2].svar); (yyval.svar)->insert((yyvsp[0].var));						}
#line 3130 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 150: /* variables: variable  */
#line 557 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.svar) = new varset; (yyval.svar)->insert((yyvsp[0].var));	}
#line 3136 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 151: /* variable: identifier  */
#line 560 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.var) = data().quantifiedvar(*(yyvsp[0].str),(yylsp[0]));		}
#line 3142 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 152: /* variable: identifier '[' theosort_pointer ']'  */
#line 561 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.var) = data().quantifiedvar(*(yyvsp[-3].str),(yyvsp[-1].sor),(yylsp[-3]));	}
#line 3148 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 153: /* theosort_pointer: pointer_name  */
#line 564 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.sor) = data().theosortpointer(*(yyvsp[0].vstr),(yylsp[0])); delete((yyvsp[0].vstr));	}
#line 3154 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 154: /* term: arterm  */
#line 569 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                        { (yyval.ter) = (yyvsp[0].ter);	}
#line 3160 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 155: /* term: domterm  */
#line 570 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.ter) = (yyvsp[0].ter);	}
#line 3166 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 156: /* function: intern_pointer '(' term_tuple ')'  */
#line 573 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.ter) = data().functerm((yyvsp[-3].nsp),*(yyvsp[-1].vter)); delete((yyvsp[-1].vter));	}
#line 3172 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 157: /* function: intern_pointer '(' ')'  */
#line 574 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.ter) = data().term((yyvsp[-2].nsp));					}
#line 3178 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 158: /* function: intern_pointer  */
#line 575 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.ter) = data().term((yyvsp[0].nsp));					}
#line 3184 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 159: /* atomarterm: function  */
#line 578 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.ter) = (yyvsp[0].ter);	}
#line 3190 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 160: /* nonatomarterm: arterm '-' arterm  */
#line 581 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.ter) = data().arterm('-',(yyvsp[-2].ter),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3196 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 161: /* nonatomarterm: '-' '(' arterm ',' arterm ')'  */
#line 582 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.ter) = data().arterm('-',(yyvsp[-3].ter),(yyvsp[-1].ter),(yylsp[-5]));	}
#line 3202 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 162: /* nonatomarterm: arterm '+' arterm  */
#line 583 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.ter) = data().arterm('+',(yyvsp[-2].ter),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3208 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 163: /* nonatomarterm: '+' '(' arterm ',' arterm ')'  */
#line 584 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.ter) = data().arterm('+',(yyvsp[-3].ter),(yyvsp[-1].ter),(yylsp[-5]));	}
#line 3214 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 164: /* nonatomarterm: arterm '*' arterm  */
#line 585 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.ter) = data().arterm('*',(yyvsp[-2].ter),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3220 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 165: /* nonatomarterm: '*' '(' arterm ',' arterm ')'  */
#line 586 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.ter) = data().arterm('*',(yyvsp[-3].ter),(yyvsp[-1].ter),(yylsp[-5]));	}
#line 3226 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 166: /* nonatomarterm: arterm '/' arterm  */
#line 587 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.ter) = data().arterm('/',(yyvsp[-2].ter),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3232 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 167: /* nonatomarterm: '/' '(' arterm ',' arterm ')'  */
#line 588 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.ter) = data().arterm('/',(yyvsp[-3].ter),(yyvsp[-1].ter),(yylsp[-5]));	}
#line 3238 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 168: /* nonatomarterm: arterm '%' arterm  */
#line 589 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.ter) = data().arterm('%',(yyvsp[-2].ter),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3244 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 169: /* nonatomarterm: '%' '(' arterm ',' arterm ')'  */
#line 590 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.ter) = data().arterm('%',(yyvsp[-3].ter),(yyvsp[-1].ter),(yylsp[-5]));	}
#line 3250 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 170: /* nonatomarterm: arterm '^' arterm  */
#line 591 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.ter) = data().arterm('^',(yyvsp[-2].ter),(yyvsp[0].ter),(yylsp[-2]));	}
#line 3256 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 171: /* nonatomarterm: '^' '(' arterm ',' arterm ')'  */
#line 592 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.ter) = data().arterm('^',(yyvsp[-3].ter),(yyvsp[-1].ter),(yylsp[-5]));	}
#line 3262 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 172: /* nonatomarterm: '-' arterm  */
#line 593 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.ter) = data().arterm("-",(yyvsp[0].ter),(yylsp[-1]));	}
#line 3268 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 173: /* nonatomarterm: ABS '(' arterm ')'  */
#line 594 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.ter) = data().arterm("abs",(yyvsp[-1].ter),(yylsp[-3]));	}
#line 3274 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 174: /* nonatomarterm: '(' nonatomarterm ')'  */
#line 595 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.ter) = (yyvsp[-1].ter);							}
#line 3280 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 175: /* nonatomarterm: INTEGER  */
#line 596 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.ter) = data().domterm((yyvsp[0].nmr),(yylsp[0]));		}
#line 3286 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 176: /* nonatomarterm: aggterm  */
#line 597 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.ter) = (yyvsp[0].ter);	}
#line 3292 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 177: /* arterm: atomarterm  */
#line 600 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.ter)=(yyvsp[0].ter);							}
#line 3298 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 178: /* arterm: nonatomarterm  */
#line 601 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.ter)=(yyvsp[0].ter);							}
#line 3304 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 179: /* domterm: FLNUMBER  */
#line 604 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { (yyval.ter) = data().domterm((yyvsp[0].dou),(yylsp[0]));		}
#line 3310 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 180: /* domterm: STRINGCONS  */
#line 605 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { (yyval.ter) = data().domterm((yyvsp[0].str),(yylsp[0]));		}
#line 3316 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 181: /* domterm: CHARCONS  */
#line 606 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                        { (yyval.ter) = data().domterm((yyvsp[0].chr),(yylsp[0]));		}
#line 3322 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 182: /* aggterm: P_CARD '(' formlist ')'  */
#line 612 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.ter) = data().aggregate(AggFunction::CARD,(yyvsp[-1].est),(yylsp[-3]));	}
#line 3328 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 183: /* aggterm: P_CARD formset  */
#line 613 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.ter) = data().aggregate(AggFunction::CARD,(yyvsp[0].est),(yylsp[-1]));	}
#line 3334 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 184: /* aggterm: P_SOM '(' termlist ')'  */
#line 614 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.ter) = data().aggregate(AggFunction::SUM,(yyvsp[-1].est),(yylsp[-3]));	}
#line 3340 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 185: /* aggterm: P_SOM termset  */
#line 615 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.ter) = data().aggregate(AggFunction::SUM,(yyvsp[0].est),(yylsp[-1]));	}
#line 3346 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 186: /* aggterm: P_PROD '(' termlist ')'  */
#line 616 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.ter) = data().aggregate(AggFunction::PROD,(yyvsp[-1].est),(yylsp[-3]));	}
#line 3352 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 187: /* aggterm: P_PROD termset  */
#line 617 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.ter) = data().aggregate(AggFunction::PROD,(yyvsp[0].est),(yylsp[-1]));	}
#line 3358 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 188: /* aggterm: P_MINAGG '(' termlist ')'  */
#line 618 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.ter) = data().aggregate(AggFunction::MIN,(yyvsp[-1].est),(yylsp[-3]));	}
#line 3364 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 189: /* aggterm: P_MINAGG termset  */
#line 619 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.ter) = data().aggregate(AggFunction::MIN,(yyvsp[0].est),(yylsp[-1]));	}
#line 3370 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 190: /* aggterm: P_MAXAGG '(' termlist ')'  */
#line 620 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                            { (yyval.ter) = data().aggregate(AggFunction::MAX,(yyvsp[-1].est),(yylsp[-3]));	}
#line 3376 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 191: /* aggterm: P_MAXAGG termset  */
#line 621 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.ter) = data().aggregate(AggFunction::MAX,(yyvsp[0].est),(yylsp[-1]));	}
#line 3382 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 192: /* formlist: formlist ',' formula  */
#line 624 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.est) = (yyvsp[-2].est); if((yyvsp[0].fom)!=NULL){data().addToFirst((yyval.est),data().set((yyvsp[0].fom),(yylsp[-2]),varset())); 	}		}
#line 3388 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 193: /* formlist: formula  */
#line 625 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.est) = data().createEnum((yylsp[0])); if((yyvsp[0].fom)!=NULL){data().addToFirst((yyval.est),data().set((yyvsp[0].fom),(yylsp[0]),varset()));} }
#line 3394 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 194: /* formset: '{' variables ':' formula '}'  */
#line 628 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.est) = data().set((yyvsp[-1].fom),(yylsp[-4]),*(yyvsp[-3].svar)); delete((yyvsp[-3].svar));	}
#line 3400 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 195: /* formset: '{' ':' formula '}'  */
#line 629 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.est) = data().set((yyvsp[-1].fom),(yylsp[-3]), varset()); }
#line 3406 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 196: /* termlist: termlist ',' term  */
#line 632 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.est) = (yyvsp[-2].est); if((yyvsp[0].ter)!=NULL){data().addToFirst((yyval.est),data().trueset((yyvsp[0].ter),(yylsp[-2]))); 	}		}
#line 3412 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 197: /* termlist: term  */
#line 633 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.est) = data().createEnum((yylsp[0])); if((yyvsp[0].ter)!=NULL){data().addToFirst((yyval.est),data().trueset((yyvsp[0].ter),(yylsp[0])));} }
#line 3418 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 198: /* termset: '{' variables ':' formula ':' term '}'  */
#line 636 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.est) = data().set((yyvsp[-3].fom),(yyvsp[-1].ter),(yylsp[-6]),*(yyvsp[-5].svar)); delete((yyvsp[-5].svar));	}
#line 3424 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 199: /* termset: '{' ':' formula ':' term '}'  */
#line 637 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.est) = data().set((yyvsp[-3].fom),(yyvsp[-1].ter),(yylsp[-5]),varset());	}
#line 3430 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 200: /* structure: STRUCT_HEADER struct_name ':' vocab_pointer '{' interpretations '}'  */
#line 645 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { data().closestructure();	}
#line 3436 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 201: /* struct_name: identifier  */
#line 648 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                        { data().openstructure(*(yyvsp[0].str),(yylsp[0])); }
#line 3442 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 211: /* empty_inter: intern_pointer '=' '{' '}'  */
#line 666 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { data().emptyinter((yyvsp[-3].nsp)); }
#line 3448 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 212: /* sort_inter: intern_pointer '=' '{' elements_es '}'  */
#line 671 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { data().sortinter((yyvsp[-4].nsp),(yyvsp[-1].sta));  }
#line 3454 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 213: /* elements_es: elements ';'  */
#line 674 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.sta) = (yyvsp[-1].sta);	}
#line 3460 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 214: /* elements_es: elements  */
#line 675 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { (yyval.sta) = (yyvsp[0].sta);	}
#line 3466 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 215: /* elements: elements ';' charrange  */
#line 678 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.sta) = (yyvsp[-2].sta); data().addElement((yyval.sta),(yyvsp[0].vcha)->first,(yyvsp[0].vcha)->second); delete((yyvsp[0].vcha));	}
#line 3472 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 216: /* elements: elements ';' intrange  */
#line 679 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.sta) = (yyvsp[-2].sta); data().addElement((yyval.sta),(yyvsp[0].vint)->first,(yyvsp[0].vint)->second); delete((yyvsp[0].vint));	}
#line 3478 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 217: /* elements: elements ';' '(' strelement ')'  */
#line 680 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.sta) = (yyvsp[-4].sta); data().addElement((yyval.sta),*(yyvsp[-1].str));						}
#line 3484 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 218: /* elements: elements ';' '(' integer ')'  */
#line 681 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.sta) = (yyvsp[-4].sta); data().addElement((yyval.sta),(yyvsp[-1].nmr));						}
#line 3490 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 219: /* elements: elements ';' '(' compound ')'  */
#line 682 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.sta) = (yyvsp[-4].sta); data().addElement((yyval.sta),(yyvsp[-1].cpo));						}
#line 3496 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 220: /* elements: elements ';' '(' floatnr ')'  */
#line 683 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.sta) = (yyvsp[-4].sta); data().addElement((yyval.sta),(yyvsp[-1].dou));						}
#line 3502 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 221: /* elements: elements ';' integer  */
#line 684 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.sta) = (yyvsp[-2].sta); data().addElement((yyval.sta),(yyvsp[0].nmr));						}
#line 3508 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 222: /* elements: elements ';' strelement  */
#line 685 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.sta) = (yyvsp[-2].sta); data().addElement((yyval.sta),*(yyvsp[0].str));						}
#line 3514 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 223: /* elements: elements ';' floatnr  */
#line 686 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.sta) = (yyvsp[-2].sta); data().addElement((yyval.sta),(yyvsp[0].dou));						}
#line 3520 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 224: /* elements: elements ';' compound  */
#line 687 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.sta) = (yyvsp[-2].sta); data().addElement((yyval.sta),(yyvsp[0].cpo));						}
#line 3526 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 225: /* elements: charrange  */
#line 688 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { (yyval.sta) = data().createSortTable(); 
													  data().addElement((yyval.sta),(yyvsp[0].vcha)->first,(yyvsp[0].vcha)->second); delete((yyvsp[0].vcha));	}
#line 3533 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 226: /* elements: intrange  */
#line 690 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { (yyval.sta) = data().createSortTable(); 
													  data().addElement((yyval.sta),(yyvsp[0].vint)->first,(yyvsp[0].vint)->second); delete((yyvsp[0].vint));	}
#line 3540 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 227: /* elements: '(' strelement ')'  */
#line 692 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.sta) = data().createSortTable(); data().addElement((yyval.sta),*(yyvsp[-1].str));	}
#line 3546 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 228: /* elements: '(' integer ')'  */
#line 693 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.sta) = data().createSortTable(); data().addElement((yyval.sta),(yyvsp[-1].nmr));	}
#line 3552 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 229: /* elements: '(' floatnr ')'  */
#line 694 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                    { (yyval.sta) = data().createSortTable(); data().addElement((yyval.sta),(yyvsp[-1].dou));	}
#line 3558 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 230: /* elements: '(' compound ')'  */
#line 695 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.sta) = data().createSortTable(); data().addElement((yyval.sta),(yyvsp[-1].cpo));	}
#line 3564 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 231: /* elements: strelement  */
#line 696 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.sta) = data().createSortTable(); data().addElement((yyval.sta),*(yyvsp[0].str));	}
#line 3570 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 232: /* elements: integer  */
#line 697 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { (yyval.sta) = data().createSortTable(); data().addElement((yyval.sta),(yyvsp[0].nmr));	}
#line 3576 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 233: /* elements: floatnr  */
#line 698 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { (yyval.sta) = data().createSortTable(); data().addElement((yyval.sta),(yyvsp[0].dou));	}
#line 3582 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 234: /* elements: compound  */
#line 699 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { (yyval.sta) = data().createSortTable(); data().addElement((yyval.sta),(yyvsp[0].cpo));	}
#line 3588 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 235: /* func_list: func_list ',' constr_func_decl  */
#line 703 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                         { (yyval.vfunc) = (yyvsp[-2].vfunc); (yyval.vfunc)->push_back((yyvsp[0].fun)); }
#line 3594 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 236: /* func_list: constr_func_decl  */
#line 704 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                   { (yyval.vfunc) = new std::vector<Function*>(); (yyval.vfunc)->push_back((yyvsp[0].fun)); }
#line 3600 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 237: /* func_list: %empty  */
#line 705 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                         {  (yyval.vfunc) = new std::vector<Function*>(); }
#line 3606 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 238: /* strelement: identifier  */
#line 709 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                        { (yyval.str) = (yyvsp[0].str);									}
#line 3612 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 239: /* strelement: STRINGCONS  */
#line 710 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.str) = (yyvsp[0].str);									}
#line 3618 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 240: /* strelement: CHARCONS  */
#line 711 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.str) = new std::string(1,(yyvsp[0].chr));	}
#line 3624 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 241: /* pred_inter: intern_pointer '=' '{' ptuples_es '}'  */
#line 716 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { data().predinter((yyvsp[-4].nsp),(yyvsp[-1].pta));		}
#line 3630 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 242: /* pred_inter: intern_pointer '=' TRUE  */
#line 717 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { data().truepredinter((yyvsp[-2].nsp));		}
#line 3636 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 243: /* pred_inter: intern_pointer '=' FALSE  */
#line 718 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { data().falsepredinter((yyvsp[-2].nsp));	}
#line 3642 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 244: /* ptuples_es: ptuples ';'  */
#line 721 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.pta) = (yyvsp[-1].pta);	}
#line 3648 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 245: /* ptuples_es: ptuples  */
#line 722 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.pta) = (yyvsp[0].pta);	}
#line 3654 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 246: /* ptuples: ptuples ';' '(' ptuple ')'  */
#line 725 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.pta) = (yyvsp[-4].pta); data().addTuple((yyval.pta),*(yyvsp[-1].vdom),(yylsp[-1])); delete((yyvsp[-1].vdom));	}
#line 3660 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 247: /* ptuples: ptuples ';' ptuple  */
#line 726 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.pta) = (yyvsp[-2].pta); data().addTuple((yyval.pta),*(yyvsp[0].vdom),(yylsp[0])); delete((yyvsp[0].vdom));	}
#line 3666 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 248: /* ptuples: ptuples ';' emptyptuple  */
#line 727 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.pta) = (yyvsp[-2].pta); data().addTuple((yyval.pta),(yylsp[0]));					}
#line 3672 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 249: /* ptuples: '(' ptuple ')'  */
#line 728 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.pta) = data().createPredTable((yyvsp[-1].vdom)->size()); data().addTuple((yyval.pta),*(yyvsp[-1].vdom),(yylsp[-1])); delete((yyvsp[-1].vdom));	}
#line 3678 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 250: /* ptuples: ptuple  */
#line 729 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.pta) = data().createPredTable((yyvsp[0].vdom)->size()); data().addTuple((yyval.pta),*(yyvsp[0].vdom),(yylsp[0])); delete((yyvsp[0].vdom));	}
#line 3684 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 251: /* ptuples: emptyptuple  */
#line 730 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.pta) = data().createPredTable(0); data().addTuple((yyval.pta),(yylsp[0]));					}
#line 3690 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 253: /* ptuple: ptuple ',' pelement  */
#line 736 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.vdom) = (yyvsp[-2].vdom); (yyval.vdom)->push_back((yyvsp[0].dom));	}
#line 3696 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 254: /* ptuple: pelement ',' pelement  */
#line 737 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.vdom) = new std::vector<const DomainElement*>(); 
												  (yyval.vdom)->push_back((yyvsp[-2].dom)); (yyval.vdom)->push_back((yyvsp[0].dom)); }
#line 3703 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 255: /* pelement: integer  */
#line 741 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.dom) = data().element((yyvsp[0].nmr));	}
#line 3709 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 256: /* pelement: identifier  */
#line 742 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.dom) = data().element(*(yyvsp[0].str));	}
#line 3715 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 257: /* pelement: CHARCONS  */
#line 743 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.dom) = data().element((yyvsp[0].chr));	}
#line 3721 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 258: /* pelement: STRINGCONS  */
#line 744 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.dom) = data().element(*(yyvsp[0].str));	}
#line 3727 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 259: /* pelement: floatnr  */
#line 745 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.dom) = data().element((yyvsp[0].dou));	}
#line 3733 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 260: /* pelement: compound  */
#line 746 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.dom) = data().element((yyvsp[0].cpo));	}
#line 3739 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 261: /* func_inter: intern_pointer '=' '{' ftuples_es '}'  */
#line 751 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { data().funcinter((yyvsp[-4].nsp),(yyvsp[-1].fta)); }
#line 3745 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 262: /* func_inter: intern_pointer '=' pelement  */
#line 752 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { FuncTable* ft = data().createFuncTable(1);
													  data().addTupleVal(ft,(yyvsp[0].dom),(yylsp[0]));
													  data().funcinter((yyvsp[-2].nsp),ft); }
#line 3753 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 263: /* func_inter: intern_pointer '=' CONSTRUCTOR  */
#line 755 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { data().constructor((yyvsp[-2].nsp));	}
#line 3759 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 264: /* ftuples_es: ftuples ';'  */
#line 758 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.fta) = (yyvsp[-1].fta);	}
#line 3765 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 265: /* ftuples_es: ftuples  */
#line 759 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.fta) = (yyvsp[0].fta);	}
#line 3771 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 266: /* ftuples: ftuples ';' ftuple  */
#line 762 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.fta) = (yyvsp[-2].fta); data().addTupleVal((yyval.fta),*(yyvsp[0].vdom),(yylsp[0])); delete((yyvsp[0].vdom));					    }
#line 3777 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 267: /* ftuples: ftuple  */
#line 763 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.fta) = data().createFuncTable((yyvsp[0].vdom)->size()); data().addTupleVal((yyval.fta),*(yyvsp[0].vdom),(yylsp[0]));	delete((yyvsp[0].vdom));	}
#line 3783 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 268: /* ftuple: ptuple "->" pelement  */
#line 766 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.vdom) = (yyvsp[-2].vdom); (yyval.vdom)->push_back((yyvsp[0].dom));	}
#line 3789 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 269: /* ftuple: pelement "->" pelement  */
#line 767 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.vdom) = new std::vector<const DomainElement*>(1,(yyvsp[-2].dom)); (yyval.vdom)->push_back((yyvsp[0].dom));	}
#line 3795 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 270: /* ftuple: emptyptuple "->" pelement  */
#line 768 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.vdom) = new std::vector<const DomainElement*>(1,(yyvsp[0].dom));	}
#line 3801 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 271: /* ftuple: "->" pelement  */
#line 769 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.vdom) = new std::vector<const DomainElement*>(1,(yyvsp[0].dom));	}
#line 3807 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 272: /* f3tuples_es: f3tuples ';'  */
#line 772 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.pta) = (yyvsp[-1].pta);	}
#line 3813 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 273: /* f3tuples_es: f3tuples  */
#line 773 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.pta) = (yyvsp[0].pta);	}
#line 3819 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 274: /* f3tuples: f3tuples ';' ftuple  */
#line 776 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.pta) = (yyvsp[-2].pta); data().addTuple((yyval.pta),*(yyvsp[0].vdom),(yylsp[0])); delete((yyvsp[0].vdom));							}
#line 3825 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 275: /* f3tuples: ftuple  */
#line 777 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.pta) = data().createPredTable((yyvsp[0].vdom)->size()); data().addTuple((yyval.pta),*(yyvsp[0].vdom),(yylsp[0])); delete((yyvsp[0].vdom));	}
#line 3831 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 276: /* proc_inter: intern_pointer '=' PROCEDURE pointer_name  */
#line 782 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { data().interByProcedure((yyvsp[-3].nsp),*(yyvsp[0].vstr),(yylsp[-3])); delete((yyvsp[0].vstr));	}
#line 3837 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 280: /* threeempty_inter: intern_pointer '<' identifier '>' '=' '{' '}'  */
#line 792 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { data().emptyinter((yyvsp[-6].nsp),*(yyvsp[-4].str)); }
#line 3843 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 281: /* threepred_inter: intern_pointer '<' identifier '>' '=' '{' ptuples_es '}'  */
#line 795 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { data().predinter((yyvsp[-7].nsp),(yyvsp[-1].pta),*(yyvsp[-5].str));		}
#line 3849 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 282: /* threepred_inter: intern_pointer '<' identifier '>' '=' '{' elements_es '}'  */
#line 796 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { data().predinter((yyvsp[-7].nsp),(yyvsp[-1].sta),*(yyvsp[-5].str));		}
#line 3855 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 283: /* threepred_inter: intern_pointer '<' identifier '>' '=' TRUE  */
#line 797 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                        { data().truepredinter((yyvsp[-5].nsp),*(yyvsp[-3].str));	}
#line 3861 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 284: /* threepred_inter: intern_pointer '<' identifier '>' '=' FALSE  */
#line 798 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                        { data().falsepredinter((yyvsp[-5].nsp),*(yyvsp[-3].str));	}
#line 3867 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 285: /* threefunc_inter: intern_pointer '<' identifier '>' '=' '{' f3tuples_es '}'  */
#line 801 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { data().funcinter((yyvsp[-7].nsp),(yyvsp[-1].pta),*(yyvsp[-5].str));		}
#line 3873 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 286: /* threefunc_inter: intern_pointer '<' identifier '>' '=' pelement  */
#line 802 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                        { PredTable* ft = data().createPredTable(1);
																			  std::vector<const DomainElement*> vd(1,(yyvsp[0].dom));
																			  data().addTuple(ft,vd,(yylsp[0]));
																			  data().funcinter((yyvsp[-5].nsp),ft,*(yyvsp[-3].str));		}
#line 3882 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 287: /* intrange: integer ".." integer  */
#line 810 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.vint) = data().range((yyvsp[-2].nmr),(yyvsp[0].nmr),(yylsp[-2])); }
#line 3888 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 288: /* charrange: CHARACTER ".." CHARACTER  */
#line 812 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.vcha) = data().range((yyvsp[-2].chr),(yyvsp[0].chr),(yylsp[-2]));	}
#line 3894 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 289: /* charrange: CHARCONS ".." CHARCONS  */
#line 813 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.vcha) = data().range((yyvsp[-2].chr),(yyvsp[0].chr),(yylsp[-2]));	}
#line 3900 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 290: /* compound: intern_pointer '(' compound_args ')'  */
#line 818 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.cpo) = data().compound((yyvsp[-3].nsp),*(yyvsp[-1].vdom)); delete((yyvsp[-1].vdom));	}
#line 3906 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 291: /* compound: intern_pointer '(' ')'  */
#line 819 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.cpo) = data().compound((yyvsp[-2].nsp));					}
#line 3912 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 292: /* compound_args: compound_args ',' floatnr  */
#line 822 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.vdom) = (yyvsp[-2].vdom); (yyval.vdom)->push_back(data().element((yyvsp[0].dou)));	}
#line 3918 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 293: /* compound_args: compound_args ',' integer  */
#line 823 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.vdom) = (yyvsp[-2].vdom); (yyval.vdom)->push_back(data().element((yyvsp[0].nmr)));	}
#line 3924 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 294: /* compound_args: compound_args ',' strelement  */
#line 824 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.vdom) = (yyvsp[-2].vdom); (yyval.vdom)->push_back(data().element(*(yyvsp[0].str)));	}
#line 3930 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 295: /* compound_args: compound_args ',' compound  */
#line 825 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { (yyval.vdom) = (yyvsp[-2].vdom); (yyval.vdom)->push_back(data().element((yyvsp[0].cpo)));	}
#line 3936 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 296: /* compound_args: floatnr  */
#line 826 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.vdom) = new std::vector<const DomainElement*>(1,data().element((yyvsp[0].dou)));	}
#line 3942 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 297: /* compound_args: integer  */
#line 827 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.vdom) = new std::vector<const DomainElement*>(1,data().element((yyvsp[0].nmr)));	}
#line 3948 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 298: /* compound_args: strelement  */
#line 828 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.vdom) = new std::vector<const DomainElement*>(1,data().element(*(yyvsp[0].str)));}
#line 3954 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 299: /* compound_args: compound  */
#line 829 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.vdom) = new std::vector<const DomainElement*>(1,data().element((yyvsp[0].cpo)));	}
#line 3960 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 300: /* integer: INTEGER  */
#line 834 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.nmr) = (yyvsp[0].nmr);		}
#line 3966 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 301: /* integer: '-' INTEGER  */
#line 835 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { (yyval.nmr) = -(yyvsp[0].nmr);		}
#line 3972 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 302: /* floatnr: FLNUMBER  */
#line 838 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.dou) = (yyvsp[0].dou);		}
#line 3978 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 303: /* floatnr: '-' FLNUMBER  */
#line 839 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.dou) = -((yyvsp[0].dou));	}
#line 3984 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 304: /* identifier: IDENTIFIER  */
#line 842 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                        { (yyval.str) = (yyvsp[0].str);	}
#line 3990 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 305: /* identifier: CHARACTER  */
#line 843 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.str) = new std::string(1,(yyvsp[0].chr)); }
#line 3996 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 306: /* identifier: IN  */
#line 844 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                    {(yyval.str) = new std::string("in");}
#line 4002 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 307: /* identifier: SAT  */
#line 845 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                     {(yyval.str) = new std::string("sat");}
#line 4008 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 308: /* asp_structure: ASP_HEADER struct_name ':' vocab_pointer '{' atoms '}'  */
#line 852 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { data().closestructure(true);	}
#line 4014 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 311: /* atoms: atoms predatom '?'  */
#line 857 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { Warning::aspQueriesAreParsedAsFacts();		}
#line 4020 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 313: /* predatom: intern_pointer '(' domain_tuple ')'  */
#line 861 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { data().predatom((yyvsp[-3].nsp),*(yyvsp[-1].vera),true);	delete((yyvsp[-1].vera));		}
#line 4026 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 314: /* predatom: intern_pointer '(' ')'  */
#line 862 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { data().predatom((yyvsp[-2].nsp),true);						}
#line 4032 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 315: /* predatom: intern_pointer  */
#line 863 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { data().predatom((yyvsp[0].nsp),true);						}
#line 4038 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 316: /* domain_tuple: domain_tuple ',' domain_element  */
#line 866 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.vera) = data().domaintuple((yyvsp[-2].vera),(yyvsp[0].dom));				}
#line 4044 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 317: /* domain_tuple: domain_tuple ',' intrange  */
#line 867 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { (yyval.vera) = data().domaintuple((yyvsp[-2].vera),(yyvsp[0].vint)); delete((yyvsp[0].vint));	}
#line 4050 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 318: /* domain_tuple: domain_tuple ',' charrange  */
#line 868 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { (yyval.vera) = data().domaintuple((yyvsp[-2].vera),(yyvsp[0].vcha)); delete((yyvsp[0].vcha));	}
#line 4056 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 319: /* domain_tuple: domain_element  */
#line 869 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.vera) = data().domaintuple((yyvsp[0].dom));					}
#line 4062 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 320: /* domain_tuple: intrange  */
#line 870 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { (yyval.vera) = data().domaintuple((yyvsp[0].vint)); delete((yyvsp[0].vint));		}
#line 4068 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 321: /* domain_tuple: charrange  */
#line 871 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { (yyval.vera) = data().domaintuple((yyvsp[0].vcha)); delete((yyvsp[0].vcha));		}
#line 4074 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 322: /* domain_element: strelement  */
#line 874 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                { (yyval.dom) = data().element(*(yyvsp[0].str)); }
#line 4080 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 323: /* domain_element: integer  */
#line 875 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.dom) = data().element((yyvsp[0].nmr)); }
#line 4086 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 324: /* domain_element: floatnr  */
#line 876 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.dom) = data().element((yyvsp[0].dou)); }
#line 4092 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 325: /* domain_element: compound  */
#line 877 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.dom) = data().element((yyvsp[0].cpo)); }
#line 4098 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 326: /* term_tuple: term_tuple ',' term  */
#line 880 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.vter) = (yyvsp[-2].vter); (yyval.vter)->push_back((yyvsp[0].ter));		}
#line 4104 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 327: /* term_tuple: term  */
#line 881 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                                { (yyval.vter) = new std::vector<Term*>(1,(yyvsp[0].ter));		}
#line 4110 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 328: /* sort_pointer_tuple: %empty  */
#line 884 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                { (yyval.vsor) = new std::vector<Sort*>(0);		}
#line 4116 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 329: /* sort_pointer_tuple: nonempty_spt  */
#line 885 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                                        { (yyval.vsor) = (yyvsp[0].vsor);							}
#line 4122 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 330: /* nonempty_spt: nonempty_spt ',' sort_pointer  */
#line 888 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { (yyval.vsor) = (yyvsp[-2].vsor); (yyval.vsor)->push_back((yyvsp[0].sor));		}
#line 4128 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 331: /* nonempty_spt: sort_pointer  */
#line 889 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { (yyval.vsor) = new std::vector<Sort*>(1,(yyvsp[0].sor));		}
#line 4134 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 332: /* instructions: PROCEDURE_HEADER proc_name proc_sig '{' LUACHUNK  */
#line 897 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                        { data().closeprocedure((yyvsp[0].sstr)); delete((yyvsp[0].sstr));	}
#line 4140 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 333: /* proc_name: identifier  */
#line 900 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                { data().openprocedure(*(yyvsp[0].str),(yylsp[0]));	}
#line 4146 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 336: /* args: args ',' identifier  */
#line 907 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                        { data().procarg(*(yyvsp[0].str));		}
#line 4152 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 337: /* args: args ',' LUAVARARG  */
#line 908 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                { data().procarg("...");		}
#line 4158 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 338: /* args: identifier  */
#line 909 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                        { data().procarg(*(yyvsp[0].str));		}
#line 4164 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;

  case 339: /* args: LUAVARARG  */
#line 910 "/builddir/build/BUILD/idp/src/parser/parser.yy"
                                                                                { data().procarg("...");		}
#line 4170 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"
    break;


#line 4174 "/builddir/build/BUILD/idp/redhat-linux-build/src/parser.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 913 "/builddir/build/BUILD/idp/src/parser/parser.yy"


#include <iostream>
#include <string>
#include <sstream>
#include "errorhandling/error.hpp"

void yyrestart(FILE*);

extern FILE* yyin;
extern bool alreadyParsed(const std::string& filename);

void yyerror(const char* s) {
	ParseInfo pi(yylloc.first_line,yylloc.first_column,data().currfile());
	Error::error(std::string(s), pi);
}

std::string getInstalledFilePath(std::string filename){
	return getInstallDirectoryPath() + "share/std/" + filename + ".idp"; 
}

std::string state = "";
void parse(const std::string& file) {
	state = "";
//	Assert(parser.include_buffer_stack.empty());
	if(alreadyParsed(file)) {
		return;
	}
	yylloc.first_line = 1;
	yylloc.first_column = 1;
	delete(yylloc.descr);
	yylloc.descr = NULL;

	std::string temp(state+file);
//	std::cerr <<"Opening PARSE" <<temp <<"\n";
	auto origstate = state;
	auto filep = GlobalData::instance()->openFile(temp.c_str(),"r");
	if(filep){
		auto index = temp.find_last_of('/');
		if(index==std::string::npos){
			state = "";
		}else{
			state = temp.substr(0, index+1);
//			std::cerr <<"State set to " <<state <<"\n";
		}
	}
	
	yyrestart(filep);
	if(not yyin){
		yyrestart(GlobalData::instance()->openFile(getInstalledFilePath(file).c_str(),"r"));
	}
	if (yyin) {
		data().currfile(file);
		yyparse();
		GlobalData::instance()->notifyParsed(temp);
		GlobalData::instance()->closeFile(yyin);
	}
	else{
		Error::unexistingfile(temp);
	}
	state = origstate;
}

void parsefile(const std::string& file) {
	parse(file);
}

void parsefiles(const std::vector<std::string>& files) {
	for(auto file : files){
		parse(file);
	}
}

void parsestdin() {
	yylloc.first_line = 1;
	yylloc.first_column = 1;
	delete(yylloc.descr);
	yylloc.descr = NULL;
	yyrestart(stdin);
	data().currfile(NULL);
	yyparse();
}

Insert& data(){
	return GlobalData::instance()->getInserter();
}
